/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 30 "core/cfg.y" /* yacc.c:339  */


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "shm_init.h"
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_core.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"
#include "async_task.h"

#include "kemi.h"
#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "daemonize.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

	#define IF_AUTO_BIND_IPV6(x) x

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLOCKLIST
	#define IF_DST_BLOCKLIST(x) x
#else
	#define IF_DST_BLOCKLIST(x) warn("dst blocklist support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer then using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp = NULL;
static int i_tmp = 0;
static struct socket_id* lst_tmp = NULL;
static struct name_lst* nl_tmp = NULL;
static int rt = 0;  /* Type of route block for find_export */
static str* str_tmp = NULL;
static str s_tmp = STR_NULL;
static struct ip_addr* ip_tmp = NULL;
static struct avp_spec* s_attr = NULL;
static select_t sel;
static select_t* sel_ptr = NULL;
static pv_spec_t* pv_spec = NULL;
static struct action *mod_func_action = NULL;
static struct lvalue* lval_tmp = NULL;
static struct rvalue* rval_tmp = NULL;
static struct rval_expr* rve_tmp = NULL;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;
extern char *routename;
extern char *default_routename;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		(x)->rname = (routename!=0)?routename:((default_routename!=0)?default_routename:"DEFAULT");\
		}\
	}while(0)



#line 234 "core/cfg.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cfg.tab.h".  */
#ifndef YY_YY_CORE_CFG_TAB_H_INCLUDED
# define YY_YY_CORE_CFG_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    FORWARD = 258,
    FORWARD_TCP = 259,
    FORWARD_TLS = 260,
    FORWARD_SCTP = 261,
    FORWARD_UDP = 262,
    EXIT = 263,
    DROP = 264,
    RETURN = 265,
    BREAK = 266,
    LOG_TOK = 267,
    ERROR = 268,
    ROUTE = 269,
    ROUTE_REQUEST = 270,
    ROUTE_FAILURE = 271,
    ROUTE_ONREPLY = 272,
    ROUTE_REPLY = 273,
    ROUTE_BRANCH = 274,
    ROUTE_SEND = 275,
    ROUTE_EVENT = 276,
    EXEC = 277,
    SET_HOST = 278,
    SET_HOSTPORT = 279,
    SET_HOSTPORTTRANS = 280,
    PREFIX = 281,
    STRIP = 282,
    STRIP_TAIL = 283,
    SET_USERPHONE = 284,
    APPEND_BRANCH = 285,
    REMOVE_BRANCH = 286,
    CLEAR_BRANCHES = 287,
    SET_USER = 288,
    SET_USERPASS = 289,
    SET_PORT = 290,
    SET_URI = 291,
    REVERT_URI = 292,
    FORCE_RPORT = 293,
    ADD_LOCAL_RPORT = 294,
    LOCAL_RPORT = 295,
    FORCE_TCP_ALIAS = 296,
    UDP_MTU = 297,
    UDP_MTU_TRY_PROTO = 298,
    UDP4_RAW = 299,
    UDP4_RAW_MTU = 300,
    UDP4_RAW_TTL = 301,
    IF = 302,
    ELSE = 303,
    SET_ADV_ADDRESS = 304,
    SET_ADV_PORT = 305,
    FORCE_SEND_SOCKET = 306,
    SET_FWD_NO_CONNECT = 307,
    SET_RPL_NO_CONNECT = 308,
    SET_FWD_CLOSE = 309,
    SET_RPL_CLOSE = 310,
    SWITCH = 311,
    CASE = 312,
    DEFAULT = 313,
    WHILE = 314,
    CFG_SELECT = 315,
    CFG_RESET = 316,
    URIHOST = 317,
    URIPORT = 318,
    MAX_LEN = 319,
    SETFLAG = 320,
    RESETFLAG = 321,
    ISFLAGSET = 322,
    SETAVPFLAG = 323,
    RESETAVPFLAG = 324,
    ISAVPFLAGSET = 325,
    METHOD = 326,
    URI = 327,
    FROM_URI = 328,
    TO_URI = 329,
    SRCIP = 330,
    SRCPORT = 331,
    DSTIP = 332,
    DSTPORT = 333,
    TOIP = 334,
    TOPORT = 335,
    SNDIP = 336,
    SNDPORT = 337,
    SNDPROTO = 338,
    SNDAF = 339,
    PROTO = 340,
    AF = 341,
    MYSELF = 342,
    MSGLEN = 343,
    UDP = 344,
    TCP = 345,
    TLS = 346,
    SCTP = 347,
    WS = 348,
    WSS = 349,
    DEBUG_V = 350,
    FORK = 351,
    FORK_DELAY = 352,
    MODINIT_DELAY = 353,
    LOGSTDERROR = 354,
    LOGFACILITY = 355,
    LOGNAME = 356,
    LOGCOLOR = 357,
    LOGPREFIX = 358,
    LOGPREFIXMODE = 359,
    LOGENGINETYPE = 360,
    LOGENGINEDATA = 361,
    XAVPVIAPARAMS = 362,
    XAVPVIAFIELDS = 363,
    LISTEN = 364,
    ADVERTISE = 365,
    VIRTUAL = 366,
    STRNAME = 367,
    ALIAS = 368,
    SR_AUTO_ALIASES = 369,
    DNS = 370,
    REV_DNS = 371,
    DNS_TRY_IPV6 = 372,
    DNS_TRY_NAPTR = 373,
    DNS_SRV_LB = 374,
    DNS_UDP_PREF = 375,
    DNS_TCP_PREF = 376,
    DNS_TLS_PREF = 377,
    DNS_SCTP_PREF = 378,
    DNS_RETR_TIME = 379,
    DNS_SLOW_QUERY_MS = 380,
    DNS_RETR_NO = 381,
    DNS_SERVERS_NO = 382,
    DNS_USE_SEARCH = 383,
    DNS_SEARCH_FMATCH = 384,
    DNS_NAPTR_IGNORE_RFC = 385,
    DNS_CACHE_INIT = 386,
    DNS_USE_CACHE = 387,
    DNS_USE_FAILOVER = 388,
    DNS_CACHE_FLAGS = 389,
    DNS_CACHE_NEG_TTL = 390,
    DNS_CACHE_MIN_TTL = 391,
    DNS_CACHE_MAX_TTL = 392,
    DNS_CACHE_MEM = 393,
    DNS_CACHE_GC_INT = 394,
    DNS_CACHE_DEL_NONEXP = 395,
    DNS_CACHE_REC_PREF = 396,
    AUTO_BIND_IPV6 = 397,
    BIND_IPV6_LINK_LOCAL = 398,
    IPV6_HEX_STYLE = 399,
    DST_BLST_INIT = 400,
    USE_DST_BLST = 401,
    DST_BLST_MEM = 402,
    DST_BLST_TTL = 403,
    DST_BLST_GC_INT = 404,
    DST_BLST_UDP_IMASK = 405,
    DST_BLST_TCP_IMASK = 406,
    DST_BLST_TLS_IMASK = 407,
    DST_BLST_SCTP_IMASK = 408,
    IP_FREE_BIND = 409,
    PORT = 410,
    STAT = 411,
    STATS_NAMESEP = 412,
    CHILDREN = 413,
    SOCKET_WORKERS = 414,
    ASYNC_WORKERS = 415,
    ASYNC_USLEEP = 416,
    ASYNC_NONBLOCK = 417,
    ASYNC_WORKERS_GROUP = 418,
    CHECK_VIA = 419,
    PHONE2TEL = 420,
    MEMLOG = 421,
    MEMDBG = 422,
    MEMSUM = 423,
    MEMSAFETY = 424,
    MEMJOIN = 425,
    MEMSTATUSMODE = 426,
    SIP_PARSER_LOG_ONELINE = 427,
    SIP_PARSER_LOG = 428,
    SIP_PARSER_MODE = 429,
    CORELOG = 430,
    SIP_WARNING = 431,
    SERVER_SIGNATURE = 432,
    SERVER_HEADER = 433,
    USER_AGENT_HEADER = 434,
    REPLY_TO_VIA = 435,
    LOADMODULE = 436,
    LOADMODULEX = 437,
    LOADPATH = 438,
    MODPARAM = 439,
    MODPARAMX = 440,
    CFGENGINE = 441,
    MAXBUFFER = 442,
    SQL_BUFFER_SIZE = 443,
    USER = 444,
    GROUP = 445,
    CHROOT = 446,
    WDIR = 447,
    RUNDIR = 448,
    MHOMED = 449,
    DISABLE_TCP = 450,
    TCP_ACCEPT_ALIASES = 451,
    TCP_ACCEPT_UNIQUE = 452,
    TCP_CONNECTION_MATCH = 453,
    TCP_CHILDREN = 454,
    TCP_CONNECT_TIMEOUT = 455,
    TCP_SEND_TIMEOUT = 456,
    TCP_CON_LIFETIME = 457,
    TCP_POLL_METHOD = 458,
    TCP_MAX_CONNECTIONS = 459,
    TLS_MAX_CONNECTIONS = 460,
    TCP_NO_CONNECT = 461,
    TCP_SOURCE_IPV4 = 462,
    TCP_SOURCE_IPV6 = 463,
    TCP_OPT_FD_CACHE = 464,
    TCP_OPT_BUF_WRITE = 465,
    TCP_OPT_CONN_WQ_MAX = 466,
    TCP_OPT_WQ_MAX = 467,
    TCP_OPT_RD_BUF = 468,
    TCP_OPT_WQ_BLK = 469,
    TCP_OPT_DEFER_ACCEPT = 470,
    TCP_OPT_DELAYED_ACK = 471,
    TCP_OPT_SYNCNT = 472,
    TCP_OPT_LINGER2 = 473,
    TCP_OPT_KEEPALIVE = 474,
    TCP_OPT_KEEPIDLE = 475,
    TCP_OPT_KEEPINTVL = 476,
    TCP_OPT_KEEPCNT = 477,
    TCP_OPT_CRLF_PING = 478,
    TCP_OPT_ACCEPT_NO_CL = 479,
    TCP_OPT_ACCEPT_HEP3 = 480,
    TCP_OPT_ACCEPT_HAPROXY = 481,
    TCP_CLONE_RCVBUF = 482,
    TCP_REUSE_PORT = 483,
    TCP_WAIT_DATA = 484,
    TCP_SCRIPT_MODE = 485,
    DISABLE_TLS = 486,
    ENABLE_TLS = 487,
    TLSLOG = 488,
    TLS_PORT_NO = 489,
    TLS_METHOD = 490,
    TLS_HANDSHAKE_TIMEOUT = 491,
    TLS_SEND_TIMEOUT = 492,
    SSLv23 = 493,
    SSLv2 = 494,
    SSLv3 = 495,
    TLSv1 = 496,
    TLS_VERIFY = 497,
    TLS_REQUIRE_CERTIFICATE = 498,
    TLS_CERTIFICATE = 499,
    TLS_PRIVATE_KEY = 500,
    TLS_CA_LIST = 501,
    DISABLE_SCTP = 502,
    ENABLE_SCTP = 503,
    SCTP_CHILDREN = 504,
    ADVERTISED_ADDRESS = 505,
    ADVERTISED_PORT = 506,
    DISABLE_CORE = 507,
    OPEN_FD_LIMIT = 508,
    SHM_MEM_SZ = 509,
    SHM_FORCE_ALLOC = 510,
    MLOCK_PAGES = 511,
    REAL_TIME = 512,
    RT_PRIO = 513,
    RT_POLICY = 514,
    RT_TIMER1_PRIO = 515,
    RT_TIMER1_POLICY = 516,
    RT_TIMER2_PRIO = 517,
    RT_TIMER2_POLICY = 518,
    MCAST_LOOPBACK = 519,
    MCAST_TTL = 520,
    MCAST = 521,
    TOS = 522,
    PMTU_DISCOVERY = 523,
    KILL_TIMEOUT = 524,
    MAX_WLOOPS = 525,
    PVBUFSIZE = 526,
    PVBUFSLOTS = 527,
    PVCACHELIMIT = 528,
    PVCACHEACTION = 529,
    HTTP_REPLY_PARSE = 530,
    VERSION_TABLE_CFG = 531,
    VERBOSE_STARTUP = 532,
    ROUTE_LOCKS_SIZE = 533,
    WAIT_WORKER1_MODE = 534,
    WAIT_WORKER1_TIME = 535,
    WAIT_WORKER1_USLEEP = 536,
    CFG_DESCRIPTION = 537,
    SERVER_ID = 538,
    KEMI = 539,
    ONSEND_ROUTE_CALLBACK = 540,
    REPLY_ROUTE_CALLBACK = 541,
    EVENT_ROUTE_CALLBACK = 542,
    RECEIVED_ROUTE_CALLBACK = 543,
    RECEIVED_ROUTE_MODE = 544,
    PRE_ROUTING_CALLBACK = 545,
    MAX_RECURSIVE_LEVEL = 546,
    MAX_BRANCHES_PARAM = 547,
    LATENCY_CFG_LOG = 548,
    LATENCY_LOG = 549,
    LATENCY_LIMIT_DB = 550,
    LATENCY_LIMIT_ACTION = 551,
    LATENCY_LIMIT_CFG = 552,
    MSG_TIME = 553,
    ONSEND_RT_REPLY = 554,
    URI_HOST_EXTRA_CHARS = 555,
    HDR_NAME_EXTRA_CHARS = 556,
    FLAGS_DECL = 557,
    AVPFLAGS_DECL = 558,
    ATTR_MARK = 559,
    SELECT_MARK = 560,
    ATTR_FROM = 561,
    ATTR_TO = 562,
    ATTR_FROMURI = 563,
    ATTR_TOURI = 564,
    ATTR_FROMUSER = 565,
    ATTR_TOUSER = 566,
    ATTR_FROMDOMAIN = 567,
    ATTR_TODOMAIN = 568,
    ATTR_GLOBAL = 569,
    ADDEQ = 570,
    SUBST = 571,
    SUBSTDEF = 572,
    SUBSTDEFS = 573,
    EQUAL = 574,
    LOG_OR = 575,
    LOG_AND = 576,
    BIN_OR = 577,
    BIN_AND = 578,
    BIN_XOR = 579,
    BIN_LSHIFT = 580,
    BIN_RSHIFT = 581,
    EQUAL_T = 582,
    DIFF = 583,
    MATCH = 584,
    INTEQ = 585,
    INTDIFF = 586,
    STREQ = 587,
    STRDIFF = 588,
    GT = 589,
    LT = 590,
    GTE = 591,
    LTE = 592,
    PLUS = 593,
    MINUS = 594,
    STAR = 595,
    SLASH = 596,
    MODULO = 597,
    NOT = 598,
    UNARY = 599,
    BIN_NOT = 600,
    DEFINED = 601,
    INTCAST = 602,
    STRCAST = 603,
    DOT = 604,
    STRLEN = 605,
    STREMPTY = 606,
    SELVAL = 607,
    NUMBER = 608,
    ID = 609,
    NUM_ID = 610,
    STRING = 611,
    IPV6ADDR = 612,
    PVAR = 613,
    AVP_OR_PVAR = 614,
    EVENT_RT_NAME = 615,
    COMMA = 616,
    SEMICOLON = 617,
    RPAREN = 618,
    LPAREN = 619,
    LBRACE = 620,
    RBRACE = 621,
    LBRACK = 622,
    RBRACK = 623,
    CR = 624,
    COLON = 625
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 198 "core/cfg.y" /* yacc.c:355  */

	long intval;
	unsigned long uval;
	char* strval;
	struct expr* expr;
	struct action* action;
	struct case_stms* case_stms;
	struct net* ipnet;
	struct ip_addr* ipaddr;
	struct socket_id* sockid;
	struct name_lst* name_l;
	struct avp_spec* attr;
	struct _pv_spec* pvar;
	struct lvalue* lval;
	struct rvalue* rval;
	struct rval_expr* rv_expr;
	select_t* select;

#line 664 "core/cfg.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CORE_CFG_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 681 "core/cfg.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  500
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   12569

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  371
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  104
/* YYNRULES -- Number of rules.  */
#define YYNRULES  952
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1787

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   625

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   648,   648,   651,   652,   653,   656,   657,   658,   659,
     660,   661,   661,   662,   662,   663,   664,   664,   665,   665,
     666,   666,   667,   668,   671,   687,   695,   709,   710,   716,
     717,   721,   722,   723,   724,   725,   728,   729,   730,   731,
     732,   733,   734,   737,   738,   741,   742,   743,   744,   745,
     749,   750,   751,   752,   753,   757,   758,   761,   762,   765,
     766,   768,   769,   772,   775,   781,   782,   786,   787,   790,
     791,   794,   800,   801,   802,   803,   804,   805,   806,   807,
     808,   811,   812,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   834,   835,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   857,   858,   859,
     860,   861,   862,   863,   864,   865,   866,   867,   868,   869,
     870,   871,   872,   873,   874,   875,   876,   877,   878,   879,
     880,   881,   882,   883,   884,   885,   886,   887,   888,   889,
     890,   891,   892,   893,   894,   895,   896,   904,   905,   906,
     907,   908,   909,   912,   913,   916,   917,   920,   921,   922,
     923,   926,   927,   930,   931,   934,   935,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   990,   991,   998,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1027,  1028,  1035,  1036,
    1043,  1044,  1051,  1052,  1059,  1060,  1067,  1068,  1075,  1076,
    1086,  1087,  1101,  1115,  1116,  1123,  1124,  1131,  1132,  1139,
    1140,  1149,  1150,  1159,  1160,  1167,  1168,  1175,  1176,  1183,
    1184,  1191,  1192,  1199,  1200,  1207,  1208,  1215,  1216,  1223,
    1224,  1231,  1232,  1239,  1240,  1247,  1248,  1255,  1256,  1263,
    1264,  1271,  1272,  1279,  1280,  1287,  1288,  1295,  1296,  1303,
    1305,  1312,  1313,  1324,  1325,  1332,  1333,  1340,  1341,  1348,
    1349,  1356,  1357,  1364,  1365,  1372,  1373,  1380,  1387,  1394,
    1401,  1408,  1415,  1416,  1423,  1424,  1431,  1432,  1439,  1440,
    1447,  1448,  1455,  1456,  1463,  1464,  1471,  1472,  1479,  1480,
    1487,  1488,  1489,  1490,  1493,  1494,  1497,  1498,  1499,  1500,
    1501,  1502,  1503,  1504,  1516,  1529,  1541,  1554,  1567,  1581,
    1594,  1608,  1621,  1635,  1648,  1662,  1664,  1675,  1676,  1677,
    1678,  1684,  1685,  1695,  1696,  1697,  1698,  1699,  1700,  1707,
    1708,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1739,
    1740,  1747,  1748,  1755,  1762,  1763,  1764,  1791,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1829,  1830,  1839,
    1840,  1849,  1850,  1859,  1860,  1869,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,  1889,  1890,  1892,  1893,  1894,
    1895,  1897,  1899,  1900,  1901,  1904,  1905,  1908,  1909,  1910,
    1913,  1914,  1917,  1918,  1919,  1927,  1932,  1937,  1942,  1947,
    1950,  1955,  1963,  1969,  1970,  1976,  1977,  1987,  1988,  1998,
    1999,  2008,  2017,  2018,  2027,  2036,  2045,  2046,  2052,  2053,
    2059,  2063,  2064,  2067,  2096,  2111,  2112,  2116,  2127,  2128,
    2132,  2133,  2137,  2144,  2160,  2161,  2164,  2167,  2174,  2190,
    2194,  2195,  2200,  2200,  2207,  2208,  2210,  2209,  2232,  2237,
    2240,  2247,  2263,  2266,  2269,  2276,  2292,  2295,  2298,  2315,
    2318,  2319,  2320,  2321,  2322,  2323,  2345,  2346,  2347,  2348,
    2351,  2352,  2353,  2354,  2357,  2358,  2364,  2365,  2366,  2367,
    2368,  2369,  2370,  2373,  2374,  2375,  2376,  2383,  2384,  2385,
    2392,  2393,  2394,  2398,  2399,  2400,  2401,  2402,  2407,  2408,
    2411,  2412,  2413,  2419,  2421,  2423,  2424,  2426,  2428,  2430,
    2432,  2434,  2435,  2437,  2438,  2439,  2440,  2442,  2444,  2446,
    2448,  2450,  2452,  2453,  2489,  2491,  2493,  2495,  2498,  2500,
    2502,  2504,  2508,  2509,  2520,  2521,  2525,  2526,  2541,  2556,
    2557,  2560,  2561,  2562,  2574,  2575,  2590,  2605,  2607,  2614,
    2656,  2657,  2660,  2661,  2662,  2665,  2666,  2667,  2668,  2669,
    2670,  2671,  2672,  2675,  2683,  2693,  2710,  2717,  2724,  2731,
    2738,  2743,  2748,  2749,  2750,  2751,  2752,  2755,  2764,  2771,
    2796,  2812,  2813,  2818,  2837,  2846,  2858,  2873,  2874,  2877,
    2877,  2887,  2888,  2889,  2890,  2891,  2892,  2893,  2894,  2895,
    2898,  2901,  2902,  2905,  2912,  2915,  2922,  2928,  2929,  2938,
    2939,  2940,  2943,  2944,  2956,  2980,  2991,  3022,  3026,  3036,
    3050,  3062,  3063,  3065,  3066,  3067,  3081,  3082,  3083,  3084,
    3085,  3086,  3087,  3091,  3092,  3093,  3106,  3112,  3113,  3114,
    3115,  3116,  3117,  3118,  3119,  3120,  3121,  3122,  3123,  3124,
    3125,  3126,  3144,  3145,  3146,  3147,  3148,  3149,  3150,  3158,
    3159,  3160,  3161,  3162,  3163,  3164,  3165,  3166,  3167,  3168,
    3170,  3172,  3173,  3174,  3175,  3176,  3177,  3180,  3198,  3199,
    3200,  3203,  3204,  3205,  3206,  3207,  3208,  3209,  3210,  3211,
    3212,  3213,  3214,  3215,  3216,  3217,  3218,  3219,  3220,  3221,
    3222,  3223,  3224,  3225,  3226,  3227,  3228,  3229,  3230,  3231,
    3232,  3233,  3234,  3235,  3236,  3237,  3245,  3253,  3261,  3269,
    3277,  3285,  3293,  3301,  3309,  3310,  3312,  3320,  3328,  3336,
    3345,  3354,  3363,  3371,  3380,  3388,  3389,  3391,  3394,  3395,
    3396,  3397,  3404,  3411,  3412,  3418,  3425,  3426,  3432,  3439,
    3440,  3446,  3449,  3452,  3453,  3454,  3457,  3458,  3459,  3468,
    3477,  3478,  3479,  3480,  3481,  3482,  3483,  3484,  3485,  3486,
    3487,  3488,  3489,  3490,  3491,  3492,  3493,  3494,  3498,  3502,
    3503,  3504,  3505,  3506,  3507,  3508,  3509,  3510,  3511,  3512,
    3513,  3514,  3515,  3516,  3517,  3518,  3519,  3520,  3521,  3522,
    3523,  3524,  3525,  3526,  3527,  3528,  3529,  3537,  3545,  3553,
    3554,  3556,  3558,  3569,  3570,  3571,  3587,  3588,  3589,  3593,
    3596,  3597,  3600,  3603,  3606,  3609,  3612,  3615,  3618,  3621,
    3624,  3627,  3628,  3629,  3632,  3633,  3634,  3634,  3667,  3669,
    3671,  3672,  3675,  3692,  3696,  3700,  3704,  3709,  3713,  3718,
    3722,  3726,  3730
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FORWARD", "FORWARD_TCP", "FORWARD_TLS",
  "FORWARD_SCTP", "FORWARD_UDP", "EXIT", "DROP", "RETURN", "BREAK",
  "LOG_TOK", "ERROR", "ROUTE", "ROUTE_REQUEST", "ROUTE_FAILURE",
  "ROUTE_ONREPLY", "ROUTE_REPLY", "ROUTE_BRANCH", "ROUTE_SEND",
  "ROUTE_EVENT", "EXEC", "SET_HOST", "SET_HOSTPORT", "SET_HOSTPORTTRANS",
  "PREFIX", "STRIP", "STRIP_TAIL", "SET_USERPHONE", "APPEND_BRANCH",
  "REMOVE_BRANCH", "CLEAR_BRANCHES", "SET_USER", "SET_USERPASS",
  "SET_PORT", "SET_URI", "REVERT_URI", "FORCE_RPORT", "ADD_LOCAL_RPORT",
  "LOCAL_RPORT", "FORCE_TCP_ALIAS", "UDP_MTU", "UDP_MTU_TRY_PROTO",
  "UDP4_RAW", "UDP4_RAW_MTU", "UDP4_RAW_TTL", "IF", "ELSE",
  "SET_ADV_ADDRESS", "SET_ADV_PORT", "FORCE_SEND_SOCKET",
  "SET_FWD_NO_CONNECT", "SET_RPL_NO_CONNECT", "SET_FWD_CLOSE",
  "SET_RPL_CLOSE", "SWITCH", "CASE", "DEFAULT", "WHILE", "CFG_SELECT",
  "CFG_RESET", "URIHOST", "URIPORT", "MAX_LEN", "SETFLAG", "RESETFLAG",
  "ISFLAGSET", "SETAVPFLAG", "RESETAVPFLAG", "ISAVPFLAGSET", "METHOD",
  "URI", "FROM_URI", "TO_URI", "SRCIP", "SRCPORT", "DSTIP", "DSTPORT",
  "TOIP", "TOPORT", "SNDIP", "SNDPORT", "SNDPROTO", "SNDAF", "PROTO", "AF",
  "MYSELF", "MSGLEN", "UDP", "TCP", "TLS", "SCTP", "WS", "WSS", "DEBUG_V",
  "FORK", "FORK_DELAY", "MODINIT_DELAY", "LOGSTDERROR", "LOGFACILITY",
  "LOGNAME", "LOGCOLOR", "LOGPREFIX", "LOGPREFIXMODE", "LOGENGINETYPE",
  "LOGENGINEDATA", "XAVPVIAPARAMS", "XAVPVIAFIELDS", "LISTEN", "ADVERTISE",
  "VIRTUAL", "STRNAME", "ALIAS", "SR_AUTO_ALIASES", "DNS", "REV_DNS",
  "DNS_TRY_IPV6", "DNS_TRY_NAPTR", "DNS_SRV_LB", "DNS_UDP_PREF",
  "DNS_TCP_PREF", "DNS_TLS_PREF", "DNS_SCTP_PREF", "DNS_RETR_TIME",
  "DNS_SLOW_QUERY_MS", "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH",
  "DNS_SEARCH_FMATCH", "DNS_NAPTR_IGNORE_RFC", "DNS_CACHE_INIT",
  "DNS_USE_CACHE", "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS",
  "DNS_CACHE_NEG_TTL", "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL",
  "DNS_CACHE_MEM", "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP",
  "DNS_CACHE_REC_PREF", "AUTO_BIND_IPV6", "BIND_IPV6_LINK_LOCAL",
  "IPV6_HEX_STYLE", "DST_BLST_INIT", "USE_DST_BLST", "DST_BLST_MEM",
  "DST_BLST_TTL", "DST_BLST_GC_INT", "DST_BLST_UDP_IMASK",
  "DST_BLST_TCP_IMASK", "DST_BLST_TLS_IMASK", "DST_BLST_SCTP_IMASK",
  "IP_FREE_BIND", "PORT", "STAT", "STATS_NAMESEP", "CHILDREN",
  "SOCKET_WORKERS", "ASYNC_WORKERS", "ASYNC_USLEEP", "ASYNC_NONBLOCK",
  "ASYNC_WORKERS_GROUP", "CHECK_VIA", "PHONE2TEL", "MEMLOG", "MEMDBG",
  "MEMSUM", "MEMSAFETY", "MEMJOIN", "MEMSTATUSMODE",
  "SIP_PARSER_LOG_ONELINE", "SIP_PARSER_LOG", "SIP_PARSER_MODE", "CORELOG",
  "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER", "USER_AGENT_HEADER",
  "REPLY_TO_VIA", "LOADMODULE", "LOADMODULEX", "LOADPATH", "MODPARAM",
  "MODPARAMX", "CFGENGINE", "MAXBUFFER", "SQL_BUFFER_SIZE", "USER",
  "GROUP", "CHROOT", "WDIR", "RUNDIR", "MHOMED", "DISABLE_TCP",
  "TCP_ACCEPT_ALIASES", "TCP_ACCEPT_UNIQUE", "TCP_CONNECTION_MATCH",
  "TCP_CHILDREN", "TCP_CONNECT_TIMEOUT", "TCP_SEND_TIMEOUT",
  "TCP_CON_LIFETIME", "TCP_POLL_METHOD", "TCP_MAX_CONNECTIONS",
  "TLS_MAX_CONNECTIONS", "TCP_NO_CONNECT", "TCP_SOURCE_IPV4",
  "TCP_SOURCE_IPV6", "TCP_OPT_FD_CACHE", "TCP_OPT_BUF_WRITE",
  "TCP_OPT_CONN_WQ_MAX", "TCP_OPT_WQ_MAX", "TCP_OPT_RD_BUF",
  "TCP_OPT_WQ_BLK", "TCP_OPT_DEFER_ACCEPT", "TCP_OPT_DELAYED_ACK",
  "TCP_OPT_SYNCNT", "TCP_OPT_LINGER2", "TCP_OPT_KEEPALIVE",
  "TCP_OPT_KEEPIDLE", "TCP_OPT_KEEPINTVL", "TCP_OPT_KEEPCNT",
  "TCP_OPT_CRLF_PING", "TCP_OPT_ACCEPT_NO_CL", "TCP_OPT_ACCEPT_HEP3",
  "TCP_OPT_ACCEPT_HAPROXY", "TCP_CLONE_RCVBUF", "TCP_REUSE_PORT",
  "TCP_WAIT_DATA", "TCP_SCRIPT_MODE", "DISABLE_TLS", "ENABLE_TLS",
  "TLSLOG", "TLS_PORT_NO", "TLS_METHOD", "TLS_HANDSHAKE_TIMEOUT",
  "TLS_SEND_TIMEOUT", "SSLv23", "SSLv2", "SSLv3", "TLSv1", "TLS_VERIFY",
  "TLS_REQUIRE_CERTIFICATE", "TLS_CERTIFICATE", "TLS_PRIVATE_KEY",
  "TLS_CA_LIST", "DISABLE_SCTP", "ENABLE_SCTP", "SCTP_CHILDREN",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "SHM_MEM_SZ", "SHM_FORCE_ALLOC", "MLOCK_PAGES", "REAL_TIME", "RT_PRIO",
  "RT_POLICY", "RT_TIMER1_PRIO", "RT_TIMER1_POLICY", "RT_TIMER2_PRIO",
  "RT_TIMER2_POLICY", "MCAST_LOOPBACK", "MCAST_TTL", "MCAST", "TOS",
  "PMTU_DISCOVERY", "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE",
  "PVBUFSLOTS", "PVCACHELIMIT", "PVCACHEACTION", "HTTP_REPLY_PARSE",
  "VERSION_TABLE_CFG", "VERBOSE_STARTUP", "ROUTE_LOCKS_SIZE",
  "WAIT_WORKER1_MODE", "WAIT_WORKER1_TIME", "WAIT_WORKER1_USLEEP",
  "CFG_DESCRIPTION", "SERVER_ID", "KEMI", "ONSEND_ROUTE_CALLBACK",
  "REPLY_ROUTE_CALLBACK", "EVENT_ROUTE_CALLBACK",
  "RECEIVED_ROUTE_CALLBACK", "RECEIVED_ROUTE_MODE", "PRE_ROUTING_CALLBACK",
  "MAX_RECURSIVE_LEVEL", "MAX_BRANCHES_PARAM", "LATENCY_CFG_LOG",
  "LATENCY_LOG", "LATENCY_LIMIT_DB", "LATENCY_LIMIT_ACTION",
  "LATENCY_LIMIT_CFG", "MSG_TIME", "ONSEND_RT_REPLY",
  "URI_HOST_EXTRA_CHARS", "HDR_NAME_EXTRA_CHARS", "FLAGS_DECL",
  "AVPFLAGS_DECL", "ATTR_MARK", "SELECT_MARK", "ATTR_FROM", "ATTR_TO",
  "ATTR_FROMURI", "ATTR_TOURI", "ATTR_FROMUSER", "ATTR_TOUSER",
  "ATTR_FROMDOMAIN", "ATTR_TODOMAIN", "ATTR_GLOBAL", "ADDEQ", "SUBST",
  "SUBSTDEF", "SUBSTDEFS", "EQUAL", "LOG_OR", "LOG_AND", "BIN_OR",
  "BIN_AND", "BIN_XOR", "BIN_LSHIFT", "BIN_RSHIFT", "EQUAL_T", "DIFF",
  "MATCH", "INTEQ", "INTDIFF", "STREQ", "STRDIFF", "GT", "LT", "GTE",
  "LTE", "PLUS", "MINUS", "STAR", "SLASH", "MODULO", "NOT", "UNARY",
  "BIN_NOT", "DEFINED", "INTCAST", "STRCAST", "DOT", "STRLEN", "STREMPTY",
  "SELVAL", "NUMBER", "ID", "NUM_ID", "STRING", "IPV6ADDR", "PVAR",
  "AVP_OR_PVAR", "EVENT_RT_NAME", "COMMA", "SEMICOLON", "RPAREN", "LPAREN",
  "LBRACE", "RBRACE", "LBRACK", "RBRACK", "CR", "COLON", "$accept", "cfg",
  "statements", "statement", "$@1", "$@2", "$@3", "$@4", "$@5",
  "listen_id", "listen_id_lst", "listen_id2", "proto", "eqproto", "port",
  "phostport", "listen_phostport", "id_lst", "intno", "flags_decl",
  "flag_list", "flag_spec", "flag_name", "avpflags_decl", "avpflag_list",
  "avpflag_spec", "assign_stm", "cfg_var_id", "cfg_var_idn", "cfg_var",
  "module_stm", "ip", "ipv4", "ipv6addr", "ipv6", "route_name",
  "route_main", "route_stm", "failure_route_main", "failure_route_stm",
  "route_reply_main", "onreply_route_stm", "$@6", "$@7",
  "branch_route_main", "branch_route_stm", "send_route_main",
  "send_route_stm", "event_route_main", "event_route_stm",
  "preprocess_stm", "equalop", "cmpop", "strop", "rve_equalop",
  "rve_cmpop", "uri_type", "eint_op_onsend", "eint_op", "eip_op_onsend",
  "eip_op", "exp_elem", "ipnet", "host", "host_if_id", "host_or_if",
  "fcmd", "stm", "actions", "action", "if_cmd", "ct_rval", "single_case",
  "case_stms", "switch_cmd", "while_cmd", "select_param", "select_params",
  "select_id", "$@8", "attr_class_spec", "attr_name_spec", "attr_spec",
  "attr_mark", "attr_id", "attr_id_num_idx", "attr_id_no_idx",
  "attr_id_ass", "attr_id_any", "attr_id_any_str", "pvar", "avp_pvar",
  "assign_op", "lval", "rval", "rve_un_op", "rval_expr", "assign_action",
  "avpflag_oper", "cmd", "$@9", "func_params", "func_param", "ret_cmd", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625
};
# endif

#define YYPACT_NINF -1237

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1237)))

#define YYTABLE_NINF -937

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2590,  -235,     5,    40,  -192,  -185,  -166,  -157,  -117,  -104,
    -101, -1237,  -100,   -86,   -79,   -75,   -72,   -61,   -14,    -5,
       0,    17,   379,   466,   477,   486,   489,   538,   542,   553,
     556,    22,    26,   671,   715,   763,   808,   820,   821,   824,
     834,   846,   872,   878,   883,   889,   898,   905,   908,   910,
     911,   917,   918,   919,   930,   946,   947,   948,   951,   968,
     971,   973,   987,   988,  1001,  1013,  1016,  1017,   568,   583,
     596,   597,   603,   606,   622,   631,   643,   654,   660,   679,
     682,   696,   744,   753,   754,   757,   812,   823,   837,   879,
     882,   903,   909,   927,   131,   156,    93,    55,    98,   211,
     928,   931,   934,   950,   952,   967,   991,  1011,  1015,  1046,
    1049,  1076,  1092,  1094,  1095,  1112,  1127,  1128,  1176,  1177,
    1202,  1203,  1205,  1206,  1019,  1050,  1051,  1056,  1207,  1208,
    1214,  1215,  1216,  1224,  1225,  1226,  1227,  1229,  1232,  1233,
    1234,  1235,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1269,
    1270,  1271,  1272,  1273,  1274,  1276,  1277,  1278,  1283,  1285,
    1286,  1287,  1288,  1318,  1319,  1321,  1322,  1323,  1324,  1326,
    1327,  1331,  1332,  1334,  1338,  1339,  1340,  1060,  1341,  1342,
    1343,  1344,  1345,  1346,  1347,  1374,  1376,  1382,  1383,  1384,
    1385,  1386,   585,  1387,  1388,  1389,  1390,  1392,  1394,  1395,
    1396,  1397,  1398,  1399,  1400,    61,    79,   167,   180,   195,
   -1237, -1237, -1237,   344,  1654, -1237,   183,   943,   964,  1025,
    1041, -1237, -1237, -1237,  -286, -1237, -1237,     8, -1237, -1237,
   -1237, -1237,   -56, -1237,    44,   266,   314,   864,    24,   317,
     320,   310,   322,   349,   352,   353,   124,   213,   356,   220,
     499,   228,   241,   252,   256,   116,   135,   586,   592,   608,
   -1237,   724, -1237,   725, -1237,   739, -1237,  -252, -1237,  -252,
   -1237,  -252, -1237,  -252, -1237,   748, -1237,   751, -1237,   788,
   -1237,   796, -1237,   818, -1237,   819, -1237,   861, -1237,  1000,
   -1237,  1024, -1237,  1052, -1237,  1144, -1237,  1250, -1237,  1367,
   -1237,  1369, -1237,  1370, -1237,  1373, -1237,  1375, -1237,  1377,
   -1237,  1378, -1237,  1379, -1237,  1022, -1237,  1380, -1237,  1381,
   -1237,  1393, -1237,  1411, -1237,  1412, -1237,  1413, -1237,  1457,
   -1237,  1539, -1237,  1540,   326,   610,   258,   615,   624,   638,
     640,   663,   259,   673,   675,   327,   329,   330,   332,   339,
     342,   347,   348,   354,   357,   676,   683,   264,   265,   693,
   -1237, -1237, -1237, -1237, -1237,   267, -1237, -1237,  1371, -1237,
    1391, -1237,   268, -1237,   703,   707,   120,   216,   234,   235,
     240,   713,   714,   718,   721,   727,   728,   358,   360,   391,
     244,   731,   733,   734,   735,    47,   736,   738, -1237,  1541,
   -1237,  1542, -1237,  1583, -1237,  1586,   740,   741,   742,   745,
     747,   749,   750,   758,   759,   760,   761,   762,   764,   765,
     394,   401,   766,   767,   768,   769,   869,   770,   771,   772,
     773,   270,   271,   272,   775,   776,   777,    27,   779,   780,
     781,   782,   783,   785,   792,   793,   798,   799,   801,   802,
     805,   806,   810,   247,   105, -1237,  1587,   815,   816,   822,
     825,   826,   827,   829,   273,   830,   831,   832,   836,   841,
     842,  1086,   465,  1588,  1589,   554,   582,   843,   847,   850,
     852,   853,   275,   277, -1237, -1237, -1237, -1237,  1368,  1365,
   -1237, -1237, -1237,  1597, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237,  -235, -1237,    69,    51,   811, -1237,    78,  1579, -1237,
      88,  1594, -1237,    96,  1595, -1237,     9,  1596, -1237,   752,
    1608, -1237, -1237, -1237, -1237,  1372, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
    1609, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237,  1615, -1237, -1237, -1237,
   -1237,  1175,  1610, -1237,  1366,  1598,  1183,    68, -1237, -1237,
   -1237, -1237, -1237,  -126, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237,  1604,  1605, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237,  1615, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,  1423,  1426,
    1429,  1650,  1679, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237,  -289,  1620,  -289, -1237,   -56,
   -1237, 12207, -1237,   -56, 12207, -1237,   -56, 12207, -1237,   -56,
   12207, -1237,  1614, -1237, -1237, -1237,  1680,  1632, 12207,    65,
   -1237,  1648,  1641,  1640,  1636,   350,  1045, -1237,  1175, -1237,
    1649,   184,   307,  1651,  1653,   279,   280,   281,   282,   284,
   -1237, -1237, -1237,  1638,   103,   104,   122,   129,   130, 11016,
   11102, 11465, -1237,   132,   137,   139,  1646,   140,   142,   143,
     144,   146,   147,   158,   162,  1647,   163,   164,   165,   168,
    1656,  1657,  1672,  1673,  1674, 11551,   169,   170,   171,  1675,
    1676,  1677,  1678,  6237, 11551,   176,   186,   188,   192,   193,
   -1237, -1237, -1237, -1237,   194, -1237, -1237, -1237,    23,  3677,
   -1237, -1237, -1237, -1237,  1074, -1237, -1237, -1237, -1237, -1237,
    1693,  1652,   202, -1237,  1689,  1645,  3747,  1695,  3817,  1697,
    3898,  1698,   249,  1666,  4181, -1237,  1696,  1668,  1175, -1237,
   -1237, -1237, -1237, -1237, -1237,  1699,   -53,  1908, -1237, -1237,
   -1237, -1237, -1237,  1706,  1717, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237,  1714, -1237,    11, -1237,    33,
   -1237,    75, -1237,   128, -1237,   208,   726, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,   648, -1237,
     648, -1237,   737, -1237, -1237,  1609, -1237, -1237,  6602,  6690,
    6778,  1719,  1720,  1721, -1237,  5608, 12139, -1237,   956, -1237,
     907, -1237,  1034, -1237, -1237, -1237,  1074, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237,  7143,  1982,  5696,  1982,  6061,  1982,
   -1237,   254, -1237,   286, -1237,  7231,  1737, -1237,   287, -1237,
     288, -1237,   289, -1237,   290, -1237,   857, -1237,   858, -1237,
    1743, -1237,   229,  1744, -1237,   291, -1237,   294, -1237,   295,
   -1237,   300,  1745,  1746,  1747,    43,   875,  7319, 11637, -1237,
      54, -1237,   859, -1237,    84,  1748,  1749,  1758,  1768, -1237,
    1129, 11637, -1237,   301, -1237,   303, -1237,   684, -1237,   743,
   -1237,   955, -1237,  1769, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,  1786,
   -1237,  1770, -1237, 11551, -1237, -1237,   215, -1237,  1771, -1237,
    1774, -1237,  1783, -1237,  1784, -1237,  1871,  1872,   752, -1237,
   12207,  1802, -1237,  -198, -1237,  1807,  1823, -1237,   -40,  -265,
   12207,  1814,  -271, -1237,   -84, -1237,   473,   621,  1815,   664,
     669,   678,   670,  1816,   722,   855,   862,  1054,  1817,  1047,
    1059,  1062,  1055,  1818,  1063,  1066,  1071,  1058, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237,  7684,  5149,  5514, -1237,  1363,
    1828, -1237, -1237, -1237, -1237, -1237, -1237,  7772,  7860,  8225,
    1838, -1237,  1884,  1886,  1887,  1888,  1178,  1846,  1825,  4262,
   -1237,  8313, -1237, -1237, -1237, -1237, -1237,  8401,  8766, -1237,
    2942,  1851, -1237, -1237,  8854,  8942,  9307,  9395, 11551, 11551,
   11551, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237,  9483,  9848,  9936, 10024, 10389, 10477, 10565, -1237,
   -1237,  1856,  1862,  1861,  1870,  1864,  1883,   101,  1245,  1885,
    1889,  1898,  1910,  1912,  1913,  1914,  1916,  1925,  1926,  1930,
    1931,  1932, -1237,  1963, -1237,  1964, -1237,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972, -1237, -1237, -1237,  1973,  1974,
   -1237,  1975,  1976, 12207,  2199, -1237,  1977,  2001,  2002,  2003,
    2004,  1879,  1880,  2005, -1237, -1237, -1237, -1237,    25, -1237,
    2006,  1890,  2008,  2009,  2010,  2011,  2013,  2014,  2015,  2018,
   11551,  1917,  2019,  1982,  1078, -1237,  1074, -1237,  2027, -1237,
   12207, 12207, 12207, 12207,  2033,  2034,  2073,  4332,  2044, -1237,
    2283,     7,  2035,  2036,  2037,  2038,  2039,  4402, -1237,   514,
   -1237,  2043, -1237,  2050, -1237,   125,   200,  2051, -1237, -1237,
     854, -1237,  2052, -1237,  2053, -1237,  2054, -1237, -1237,   860,
   -1237,  2055, -1237,  2056, -1237,  2057, -1237, -1237,   873, -1237,
    2081, -1237,  2082, -1237,  2083, -1237, -1237,   895, -1237,  2084,
   -1237,  2085, -1237,  2086, -1237, -1237,  2091,  1294, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237,  1294, -1237, -1237,
    1294, -1237, -1237, -1237,  2030, -1237,  2092,  2077,  1655,  2079,
    2337,  2080,  3085, -1237, -1237, -1237, -1237, -1237, -1237,  2161,
    1294, -1237,  1294, -1237,   666, -1237,  2231,  1615,  2021,  2103,
   -1237,    -2,  1294,   632, -1237,  1151, -1237,  3296, -1237,  3316,
   -1237,  3658,  1284,  3102,  1349, -1237,   915, -1237,   915, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237,  1294, -1237,   666, -1237,
    2090, -1237, -1237,  2095, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237,  4545, 12069, -1237, -1237, -1237, -1237,
   -1237,   378,  1175, -1237,  2093,  6149,  2078, -1237, -1237,     3,
   -1237, 11706, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
    1982,  1082, -1237, -1237, -1237,  -289, -1237, -1237,   250,  4766,
    4909,  4979,  5049, -1237, -1237,  -195, -1237,  2094, -1237, -1237,
    2101, -1237, -1237, -1237, -1237, -1237, -1237,  2097,  2099,  2100,
    2104, -1237, -1237, -1237, -1237,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2141,  2142,
    2143,  2144,  2145,  2146,  2147,  2148,   532,  1828, -1237, -1237,
   -1237, -1237, -1237, 11551,    46,  2096,  2149,  2150, -1237, -1237,
   -1237, -1237,  2088, -1237,  2151, 10930,  2155,  1982, 12207, -1237,
   -1237,  2153,  2594, 11551, -1237,  2154,  2164,  2165, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237,  2355, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237,  2162,  2166, -1237,  3155, -1237,  1615, -1237, -1237, -1237,
   -1237,  -198, 12207,  2159,  2163,  1290,  3030, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, 11551, -1237,  3100, 12207,
   12207, -1237,  3170,  2928,  3313,  3534, -1237
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   491,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     490,    22,    23,     0,     0,     4,     0,     0,     0,     0,
       0,     8,     9,     6,     0,   488,    10,     0,    15,     7,
     489,   544,     0,   545,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     105,     0,   107,     0,   109,     0,   111,     0,   113,     0,
     115,     0,   117,     0,   119,     0,   121,     0,   123,     0,
     125,     0,   127,     0,   129,     0,   131,     0,   133,     0,
     135,     0,   137,     0,   139,     0,   141,     0,   145,     0,
     143,     0,   147,     0,   149,     0,   151,     0,   153,     0,
     155,     0,   159,     0,   157,     0,   161,     0,   163,     0,
     165,     0,   167,     0,   169,     0,   171,     0,   173,     0,
     175,     0,   177,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     503,   502,   505,   504,   507,     0,   506,   512,     0,   516,
       0,   518,     0,   517,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   279,     0,
     281,     0,   283,     0,   285,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   419,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    60,    66,    65,    59,    61,    63,
      68,    71,    67,    69,   561,   560,   563,   562,   565,   564,
       1,     5,     3,     0,     0,     0,    12,     0,     0,    14,
       0,     0,    17,     0,     0,    19,     0,     0,    21,     0,
       0,   542,   527,   528,   529,     0,   477,   476,   479,   478,
     475,   474,   481,    31,    32,    33,    34,    35,   480,   483,
       0,    57,   482,   485,   484,   487,   486,    73,    72,    75,
      74,    77,    76,    79,    78,    81,    80,    83,    82,    85,
      84,    87,    86,    89,    88,    91,    90,    93,    92,    95,
      94,    97,    96,    99,    98,   375,   643,   641,   642,    25,
     524,     0,     0,    30,    50,     0,    55,   363,    24,   521,
     525,   522,   644,    26,   377,   376,   379,   378,   101,   100,
     103,   102,   104,   106,   108,   110,   112,   114,   116,   118,
     120,   122,   124,   126,   128,   130,   132,   134,   136,   138,
     140,   144,   142,   146,   148,   150,   152,   154,   158,   156,
     160,   162,   164,   166,   168,   170,   172,   174,   176,   179,
     178,   185,   180,   189,   188,   187,   186,   191,   190,   193,
     192,   195,   194,   197,   196,   199,   198,   201,   200,   203,
     202,   205,   204,   207,   206,   209,   208,   211,   210,   213,
     212,   215,   214,   217,   216,   219,   218,   221,   220,   223,
     222,   225,   224,   352,   351,   354,   353,   356,   355,   362,
     361,   509,   508,     0,     0,   520,   519,   182,   181,   184,
     183,   230,   229,   228,   233,   232,   231,   236,   235,   234,
     239,   238,   237,   242,   241,   240,   244,   243,   246,   245,
     248,   247,   250,   249,   252,   251,   254,   253,   256,   255,
     258,   257,   260,   259,   263,   261,   262,   265,   264,   267,
     266,   269,   268,   271,     0,   270,   273,   272,   275,   274,
     277,   276,   278,   280,   282,   284,   287,   286,   289,   288,
     291,   290,   293,   292,   295,   294,   297,   296,   299,   298,
     301,   300,   303,   302,   305,   304,   307,   306,   309,   308,
     311,   310,   313,   312,   315,   314,   317,   316,   319,   318,
     321,   320,   323,   322,   325,   324,   330,   326,   327,   328,
     329,   342,   341,   344,   343,   332,   331,   334,   333,   336,
     335,   338,   337,   340,   339,   346,   345,   348,   347,   350,
     349,   381,   380,   383,   382,   385,   384,   387,   386,   389,
     388,   391,   390,   393,   392,   395,   394,   397,   396,   399,
     398,   401,   400,   403,   402,   405,   404,   407,   406,   409,
     408,   411,   410,   414,   412,   413,   417,   415,   416,   418,
     421,   420,   423,   422,   425,   424,   427,   426,   429,   428,
     431,   430,   433,   432,   227,   226,   435,   434,   437,   436,
     439,   438,   441,   440,   443,   442,   445,   444,     0,     0,
       0,     0,     0,   457,   456,   458,   459,   463,   462,   461,
     460,   465,   464,   467,   466,   469,   468,   471,   470,   473,
     472,   358,   357,   360,   359,     0,     0,     0,   534,     0,
     535,     0,   539,     0,     0,   552,     0,     0,   556,     0,
       0,   559,     0,   493,   494,   492,     0,     0,     0,     0,
      58,     0,    27,     0,     0,     0,     0,    56,     0,   364,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      62,    64,    70,     0,     0,     0,     0,     0,     0,   948,
     945,   949,   952,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     901,   903,   905,   908,     0,     0,     0,     0,     0,   922,
     924,   926,   928,     0,     0,     0,     0,     0,     0,     0,
     778,   779,   780,   703,     0,   715,   716,   661,     0,     0,
     653,   656,   657,   658,     0,   707,   708,   718,   719,   720,
       0,     0,     0,   649,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   548,     0,     0,     0,    29,
     526,    54,    44,    43,    51,    52,   371,   365,   648,   643,
     646,   647,   645,     0,     0,   447,   446,   449,   448,   451,
     450,   453,   452,   455,   454,     0,   791,     0,   813,     0,
     824,     0,   835,     0,   802,     0,     0,   587,   588,   589,
     600,   593,   601,   594,   599,   591,   598,   590,     0,   592,
       0,   595,     0,   596,   689,   735,   733,   734,     0,     0,
       0,     0,     0,     0,   722,     0,     0,   721,     0,   597,
       0,   602,     0,   728,   727,   726,     0,   709,   711,   710,
     723,   724,   725,   736,     0,   947,     0,   944,     0,   951,
     839,     0,   856,     0,   860,     0,     0,   864,     0,   883,
       0,   886,     0,   867,     0,   873,     0,   870,     0,   876,
       0,   879,     0,     0,   892,     0,   895,     0,   889,     0,
     898,     0,     0,     0,     0,     0,     0,     0,     0,   914,
       0,   917,     0,   920,     0,     0,     0,     0,     0,   681,
       0,     0,   931,     0,   934,     0,   843,     0,   846,     0,
     849,     0,   938,     0,   662,   655,   654,   532,   652,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,     0,
     701,   704,   717,     0,   660,   854,     0,   659,     0,   537,
       0,   550,     0,   554,     0,   499,   495,   496,     0,   543,
       0,     0,    28,     0,   372,     0,     0,   366,     0,     0,
       0,     0,     0,   636,     0,   781,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   606,   566,
     567,   575,   568,   569,   574,     0,     0,     0,   631,     0,
       0,   776,   757,   760,   738,   761,   739,     0,     0,     0,
       0,   946,   709,   710,   724,   725,     0,     0,     0,     0,
     610,     0,   615,   570,   571,   572,   573,     0,     0,   627,
       0,   704,   759,   737,     0,     0,     0,     0,     0,     0,
       0,   576,   577,   582,   578,   579,   580,   581,   583,   584,
     585,   586,     0,     0,     0,     0,     0,     0,     0,   943,
     950,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   875,     0,   878,     0,   881,     0,     0,     0,
       0,     0,     0,     0,     0,   900,   902,   904,     0,     0,
     907,     0,     0,     0,   663,   650,     0,     0,     0,     0,
       0,    45,     0,     0,   921,   923,   925,   927,     0,   683,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     939,     0,     0,   777,     0,   714,     0,   712,     0,   713,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    53,
     373,   367,     0,     0,     0,     0,     0,     0,   792,     0,
     790,     0,   783,     0,   784,     0,     0,     0,   782,   814,
       0,   812,     0,   805,     0,   806,     0,   804,   825,     0,
     823,     0,   816,     0,   817,     0,   815,   836,     0,   834,
       0,   827,     0,   828,     0,   826,   803,     0,   801,     0,
     794,     0,   795,     0,   793,   605,     0,   603,   621,    36,
      37,    38,    39,    40,    41,    42,   619,   620,   618,   616,
     617,   630,   628,   629,   684,   688,   690,     0,     0,     0,
       0,     0,     0,   732,   754,   731,   730,   729,   609,     0,
     607,   614,   612,   613,   611,   626,     0,    57,     0,   634,
     622,   624,   623,     0,   772,   753,   771,   752,   767,   745,
     768,   746,   747,   748,   749,   762,   740,   763,   741,   764,
     742,   765,   743,   766,   744,   770,   751,   769,   750,   840,
       0,   837,   857,     0,   861,   859,   858,   862,   865,   863,
     884,   882,   887,   885,   868,   866,   874,   872,   871,   869,
     880,   877,   893,   891,   896,   894,   890,   888,   899,   897,
     909,   906,   911,   910,     0,     0,   913,   912,   916,   915,
     919,     0,     0,   918,     0,     0,     0,   680,   678,     0,
     932,     0,   935,   933,   841,   842,   844,   845,   847,   848,
     942,     0,   941,   702,   706,     0,   853,   704,     0,     0,
       0,     0,     0,   497,   498,     0,   547,     0,   374,   368,
       0,   510,   511,   513,   515,   514,   533,     0,     0,     0,
       0,   640,   638,   639,   637,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   773,   755,
     774,   756,   775,     0,     0,     0,     0,     0,   651,   664,
      49,    46,    47,   682,     0,     0,     0,   665,   671,   679,
     677,    57,     0,     0,   937,     0,     0,     0,   538,   551,
     555,   558,   500,   501,   523,   369,   788,   789,   786,   787,
     785,   810,   811,   808,   809,   807,   821,   822,   819,   820,
     818,   832,   833,   830,   831,   829,   799,   800,   797,   798,
     796,     0,     0,   687,     0,   635,   633,   632,   705,   838,
     855,     0,   674,     0,     0,     0,     0,   929,   930,   940,
     852,   851,   850,   370,   686,   685,     0,    48,     0,   675,
     669,   676,     0,     0,     0,     0,   758
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1237, -1237, -1237,  2300, -1237, -1237, -1237, -1237, -1237,  -435,
    1470,  1590,  -233,  1251, -1236, -1237, -1237,  -226,  -238, -1237,
    1617, -1237,  -205, -1237,  1622, -1237, -1237, -1237,  1299, -1237,
   -1237, -1064,  2152,  1958,  2179,  -680, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1082, -1237, -1054, -1237, -1237,  1252, -1237, -1237, -1237,
    1253, -1237, -1237,  -139,  -741, -1237,   -41, -1182,  -888,  -987,
   -1237,   838,   925, -1237, -1237, -1237,   863, -1237, -1237, -1237,
   -1237,  1124, -1055,  -592,  -916, -1237,  -852, -1237, -1237, -1237,
    -618,  -884, -1237, -1237, -1237, -1237,   -66, -1038, -1237, -1237,
   -1237, -1237,   835, -1237
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   583,
     943,   584,   585,  1506,  1054,  1403,   586,   587,  1117,   221,
     487,   488,   489,   222,   492,   493,   223,   224,   936,   225,
     226,   588,   589,   590,   591,   525,   505,   506,   508,   509,
     227,   228,   938,  1046,   511,   512,   514,   515,   517,   518,
     229,  1284,  1318,  1285,  1347,  1348,  1118,  1119,  1120,  1121,
    1122,  1123,  1540,  1257,   592,   593,  1124,  1394,  1019,  1020,
    1021,  1706,  1618,  1619,  1022,  1023,  1515,  1516,  1125,  1290,
    1219,  1220,  1221,  1126,  1127,  1128,  1129,  1027,  1130,  1428,
    1131,  1132,  1223,  1030,  1133,  1134,  1306,  1031,  1032,  1033,
    1203,  1631,  1632,  1034
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     542,   491,   822,   548,   538,  1025,   231,  1439,  1025,  1409,
     931,  1025,  1251,  1256,  1025,  1261,  1286,  1266,  1287,  1271,
    1289,  1276,  1025,   260,  1204,   539,  1614,   262,   821,   605,
     595,   606,  1208,   607,  1258,   608,  1036,  1029,  1317,  1038,
    1029,   233,  1040,  1029,  1388,   526,  1029,  1755,   746,  1208,
    1044,  1208,   920,  1208,  1029,  1396,   367,  1208,  1244,  1245,
    1615,  1616,   484,   519,  1311,   485,  1045,   486,  1320,  1026,
     918,  1321,  1026,  1252,   540,  1026,  1263,  1307,  1026,   922,
     490,   520,  1615,  1616,   230,  1400,  1026,   540,   541,   925,
    1449,  1444,  1450,  1445,   364,  1259,   640,   928,  1307,   369,
    1307,   541,  1202,  1025,  1076,  1078,   856,   662,   664,   666,
     668,   670,   672,   674,   676,   678,   680,   575,  1649,  1650,
    1025,   701,  1025,  1080,  1025,   557,  1661,   234,  1025,  1268,
    1082,  1084,   360,  1140,   235,  1029,   594,  1264,  1142,  1307,
    1144,  1147,  1052,  1149,  1151,  1153,   942,  1155,  1157,   729,
     731,   733,  1029,   236,  1029,  1053,  1029,   362,  1722,  1159,
    1029,  1723,   237,  1161,  1164,  1166,  1168,  1026,   494,  1170,
    1179,  1181,  1183,   533,   534,   535,   536,  1192,   948,   949,
     950,   496,   785,   787,  1026,  1058,  1026,  1194,  1026,  1196,
    1269,  1395,  1026,  1198,  1200,  1202,   498,   503,   504,  1302,
    1025,  1663,   238,  1225,  1395,   533,   534,   535,   536,  1273,
    1060,  1062,   371,   951,   559,   239,  1424,   704,   240,   241,
    1302,   563,  1302,   952,   533,   534,   535,   536,  1309,   567,
    1373,  1305,  1029,   242,   894,   707,   710,   898,   900,   963,
     243,   713,   569,  1035,   244,   734,  1037,   245,   853,  1039,
    1235,  1716,  1305,   571,  1305,  1351,  1539,   573,   246,   643,
     655,  1302,  1025,  1303,  1026,   685,   687,   528,   691,   695,
    1274,   809,   811,   813,   874,  1025,   911,  1451,   913,  1452,
    1065,  1067,  1069,  1071,  1303,  1073,  1303,  1354,  1360,  1362,
    1364,  1366,  1377,  1305,  1029,  1379,  1381,   522,   523,   540,
     524,  1383,  1410,  1028,  1412,   247,  1028,  1029,  1061,  1028,
    1427,   547,  1028,   541,   248,   530,  1442,  1246,   543,   249,
    1028,   545,  1208,   549,  1025,  1303,  1026,   639,   661,  1024,
     663,   665,  1024,   667,  1025,  1024,   250,  1455,  1024,  1026,
     669,   261,  1429,   671,   500,   263,  1024,  1456,   673,   675,
     551,  1051,  1437,   553,   555,   677,  1029,   561,   679,   728,
     947,   730,  1447,   540,   744,  1253,  1029,  1254,   580,  1709,
    -540,  1637,   232,   521,  1255,  1701,  -557,   541,   582,  1700,
     576,   577,   578,   579,   580,  1205,   744,  1253,  1026,  1260,
     580,  1617,   732,  1025,   582,   784,  1389,   527,  1026,  1756,
     582,  1028,   786,   580,   580,  -541,  1390,   576,   577,   578,
     579,   580,   365,   582,   582,   485,  -531,   486,  1028,   368,
    1028,   582,  1028,  1699,   537,  1029,  1028,  1024,   744,  1253,
    -546,  1265,   580,   485,  -530,   486,   919,   576,   577,   578,
     579,   580,   582,  -536,  1024,   923,  1024,  1289,  1024,   366,
    1208,   582,  1024,  -549,  1289,   926,   537,  1026,   857,   858,
    1208,  -553,   370,   929,  1575,  -936,   893,  1077,  1079,   576,
     577,   578,   579,   580,   702,   537,   703,  1025,   558,  1662,
     581,   744,  1253,   582,  1270,   580,  1081,   361,   576,   577,
     578,   579,   580,  1083,  1085,   582,  1141,  1304,  1028,   581,
     565,  1143,   582,  1145,  1148,  1604,  1150,  1152,  1154,  1029,
    1156,  1158,   363,  1056,  1025,  1025,  1025,  1025,  1304,  1013,
    1304,  1025,  1160,   495,  1024,  1777,  1162,  1165,  1167,  1169,
     372,  1025,  1171,  1180,  1182,  1184,   497,  1059,   577,   578,
    1193,  1026,  1639,  1640,  1641,  1642,  1029,  1029,  1029,  1029,
    1195,   499,  1197,  1029,  1664,   897,  1199,  1201,  -936,  1304,
    1028,   744,  1253,  1029,  1275,   580,  1226,   373,   540,   560,
     705,  1425,   706,  1028,  1016,   582,   564,  1657,  1026,  1026,
    1026,  1026,   541,   899,   568,  1026,  1024,   596,   708,   711,
     709,   712,  1374,   598,   714,  1026,   715,   570,   735,  1024,
     736,   854,  1236,   855,   485,  1237,   486,  1352,   572,   600,
    1353,   641,   574,   942,   644,   656,   645,  1208,  1395,   529,
     686,   688,  1028,   692,   696,   647,   810,   812,   814,   875,
    1757,   912,  1028,   914,  1426,  1066,  1068,  1070,  1072,   649,
    1074,   651,  1355,  1361,  1363,  1365,  1367,  1378,  1024,   540,
    1380,  1382,  1208,  1208,  1208,  1208,  1384,  1411,  1024,  1413,
    1059,   577,   578,   541,   653,   540,   540,   531,   540,   540,
     544,   540,   264,   546,   657,   550,   659,   681,   540,   541,
     541,   540,   541,   541,   683,   541,   540,   540,  1025,  1025,
    1052,  1028,   541,   540,   689,   541,   540,   540,   251,   540,
     541,   541,   552,  1053,   697,   554,   556,   541,   699,   562,
     541,   541,   491,   541,   716,   718,   266,  1024,  1052,   720,
    1029,  1029,   722,  1025,  1025,  1025,  1025,  1278,   724,   726,
     540,  1053,   737,   540,   739,   741,   743,   748,  1288,   750,
     540,   756,   758,   760,   541,  1397,   762,   541,   764,  1401,
     766,   768,  1026,  1026,   541,  1029,  1029,  1029,  1029,   770,
     772,   774,   776,   778,   268,   780,   782,   788,   790,   792,
     794,   801,   803,   805,   807,  1028,   815,   817,   819,  1208,
     823,   825,   827,   829,   831,   252,   833,  1026,  1026,  1026,
    1026,  1208,  1025,   835,   837,  1208,   253,  1208,  1208,   839,
     841,  1024,   843,   845,   540,   254,   847,   849,   255,   270,
     933,   851,  1028,  1028,  1028,  1028,   860,   862,   541,  1028,
    1766,   272,   274,   864,  1029,   276,   866,   868,   870,  1028,
     872,   876,   878,   880,  1453,   278,  1454,   882,  1024,  1024,
    1024,  1024,   884,   886,   901,  1024,  1025,   280,   903,  1025,
    1025,   905,   566,   907,   909,  1024,  1026,   256,  1368,  1370,
    1398,   257,  1025,  1025,  1025,   532,  1025,  1658,  1025,  1025,
     796,   540,   258,   282,  1778,   259,  1391,  1782,  1029,   284,
    1018,  1029,  1029,  1018,   286,   541,  1018,   334,  1751,  1018,
     288,  1784,  1785,   540,  1029,  1029,  1029,  1018,  1029,   290,
    1029,  1029,   335,  1135,  1137,  1139,   292,   541,  1312,   294,
    1026,   296,   298,  1026,  1026,   336,   337,  1666,   300,   302,
     304,   540,   338,  1671,  1375,   339,  1026,  1026,  1026,  1178,
    1026,   306,  1026,  1026,   471,   541,  1676,  1190,  1191,   597,
    1262,   340,  1267,  1392,  1272,   599,  1277,   308,   310,   312,
     341,  1402,   314,   533,   534,   535,   536,  1310,  1681,   507,
    1455,   601,   342,   642,   533,   534,   535,   536,   646,   316,
    1456,   540,   318,   343,   320,  1279,  1280,   648,  1018,   344,
    1282,  1283,  1457,   510,  1458,   541,  1028,  1028,   322,   324,
     265,   650,  1415,   652,  1417,  1018,  1419,  1018,   345,  1018,
    1634,   346,   326,  1018,  1342,  1343,  1344,  1345,  1346,  1455,
    1443,  1446,  1024,  1024,   328,   347,   654,   330,   332,  1456,
     398,  1028,  1028,  1028,  1028,  1460,   658,  1461,   660,   682,
    1462,  1466,  1463,  1467,   267,  1319,   684,  1414,   485,  1464,
     486,  1465,  1292,  1294,  1296,   513,   690,  1024,  1024,  1024,
    1024,   400,   402,  1279,  1280,  1281,   698,   404,  1282,  1283,
     700,   455,   516,   348,  1279,  1280,   717,   719,  1323,  1282,
    1283,   721,   349,   350,   723,  1018,   351,   602,   603,  1358,
     725,   727,   269,  1469,   738,  1470,   740,   742,   744,   749,
    1028,   751,   604,   757,   759,   761,  1416,   485,   763,   486,
     765,   609,   767,   769,   610,   934,   935,   797,   798,   799,
     800,   771,   773,   775,   777,   779,  1024,   781,   783,   789,
     791,   793,   795,   802,   804,   806,   808,   271,   816,   818,
     820,   352,   824,   826,   828,   830,   832,  1018,   834,   273,
     275,   611,   353,   277,  1028,   836,   838,  1028,  1028,   612,
    1018,   840,   842,   279,   844,   846,   354,  1423,   848,   850,
    1028,  1028,  1028,   852,  1028,   281,  1028,  1028,   861,   863,
    1024,   613,   614,  1024,  1024,   865,   921,  1702,   867,   869,
     871,  1541,   873,   877,   879,   881,  1024,  1024,  1024,   883,
    1024,   283,  1024,  1024,   885,   887,   902,   285,   355,  1018,
     904,   356,   287,   906,   537,   908,   910,  1667,   289,  1018,
    1369,  1371,  1399,  1672,   615,   537,  1471,   291,  1472,  1497,
    1507,  1510,   357,  1473,   293,  1474,  1677,   295,   358,   297,
     299,  1518,  1520,  1522,  1279,  1280,   301,   303,   305,  1282,
    1283,  1313,  1314,  1315,  1316,  1530,   359,   374,  1682,   307,
     375,  1532,  1534,   376,  1542,  1344,  1345,  1346,  1545,  1547,
    1549,  1551,  1552,  1553,  1554,   309,   311,   313,  1018,   377,
     315,   378,   533,   534,   535,   536,  1556,  1558,  1560,  1562,
    1564,  1566,  1568,  1279,  1280,  1281,   379,   317,  1282,  1283,
     319,  1781,   321,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,  1695,   323,   325,  1418,   485,
     380,   486,   976,   977,   978,   979,   980,   981,   982,   983,
     327,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     381,   993,   329,   994,   382,   331,   333,   995,   399,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  -668,  -668,  1004,
    1005,  1006,  1018,   616,  1630,  1007,  1008,  1009,  1010,  1011,
    1012,  1279,  1280,  1281,  1511,   383,  1282,  1283,   384,   401,
     403,   888,   889,   890,   891,   405,   892,   617,   629,   456,
    1209,  1210,  1211,  1212,  1213,  1214,  1215,  1216,  1217,  1018,
    1018,  1018,  1018,  1455,  1455,   385,  1018,  1455,   576,   577,
     578,   579,   580,  1456,  1456,   618,  1018,  1456,  1478,   581,
    1479,   386,   582,   387,   388,  1475,  1484,  1476,  1485,  1493,
    1480,  1494,  1481,  1482,  1487,  1483,  1488,  1489,  1218,  1490,
    1715,   389,  1491,  1717,  1492,  1087,  1088,  1089,  1090,  1635,
    1092,  1636,  1094,  1713,  1096,  1714,   390,   391,  1752,  1324,
    1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,
    1335,  1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,
    1345,  1346,  1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,  1341,  1342,
    1343,  1344,  1345,  1346,  1408,   392,   393,   619,  1324,  1325,
    1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,
    1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,
    1346,   394,   395,   537,   396,   397,   406,   407,   576,   577,
     578,   579,   580,   408,   409,   410,   576,   577,   578,   579,
     580,  1524,   582,   411,   412,   413,   414,   581,   415,  1707,
     582,   416,   417,   418,   419,  1712,   420,   421,   422,   423,
     424,   425,   426,  1018,  1018,  1324,  1325,  1326,  1327,  1328,
    1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,
    1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,   427,   428,
     429,   430,   431,   432,  1013,   433,   434,   435,  1018,  1018,
    1018,  1018,   436,   620,   437,   438,   439,   440,  1576,  1329,
    1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,
    1340,  1341,  1342,  1343,  1344,  1345,  1346,  1754,  1338,  1339,
    1340,  1341,  1342,  1343,  1344,  1345,  1346,   441,   442,  1707,
     443,   444,   445,   446,  1014,   447,   448,  1630,  1015,  1016,
     449,   450,  1017,   451,    -2,   501,  -668,   452,   453,   454,
     457,   458,   459,   460,   461,   462,   463,  1018,   -11,   -11,
     -13,     2,     3,   -16,   -18,   -20,  1331,  1332,  1333,  1334,
    1335,  1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,
    1345,  1346,     4,   464,     5,   465,     6,     7,     8,     9,
      10,   466,   467,   468,   469,   470,   472,   473,   474,   475,
    1783,   476,    11,   477,   478,   479,   480,   481,   482,   483,
     621,  1018,   622,   623,  1018,  1018,   624,   693,   625,   915,
     626,   627,   628,   630,   631,   916,   945,  1018,  1018,  1018,
     939,  1018,   955,  1018,  1018,   956,   632,   694,   957,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,   633,   634,   635,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
     636,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   637,   638,   752,   753,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   754,   191,   192,   755,
     859,   895,   896,   193,   924,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   917,   927,
     930,   937,   940,   932,   941,   953,   954,   580,   946,   958,
     207,   208,   209,   961,  1041,  1324,  1325,  1326,  1327,  1328,
    1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,
    1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,   959,  1042,
    1043,  1047,  1048,  1049,  1050,  1057,  1075,  1063,   210,  1064,
    1146,  1163,  1222,  1228,  1224,  1238,   211,  1241,  1689,  1247,
    1172,  1173,  1202,   212,  -636,  -636,  -636,  -636,  -636,  -636,
    -636,  -636,  -636,  -636,  -636,  -636,  1174,  1175,  1176,  1185,
    1186,  1187,  1188,  -636,  -636,  -636,  -636,  -636,  -636,  -636,
    -636,  1227,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,
    -636,  1240,  -636,  1230,  -636,  1232,  1234,  1248,  -636,  1243,
    -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  1249,  1250,
    -636,  -636,  -636,  1297,  1298,  1299,  -636,  -636,  -636,  -636,
    -636,  -636,  1202,  1359,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  1372,  1376,  1385,  1386,
    1387,  1404,  1405,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  1406,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  1407,  -604,  1420,  -604,  1421,  1430,  1422,  -604,  1431,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  1432,  1433,
    -604,  -604,  -604,  1434,  1435,  1438,  -604,  -604,  -604,  -604,
    -604,  -604,  1288,  1440,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,  -608,  -608,  -608,  1441,  1448,  1459,  1468,
    1477,  1486,  1514,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  1526,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  1523,  -608,  -707,  -608,  -708,  -719,  -720,  -608,  1525,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  1543,  1569,
    -608,  -608,  -608,  1570,  1571,  1573,  -608,  -608,  -608,  -608,
    -608,  -608,  1288,  1572,  -625,  -625,  -625,  -625,  -625,  -625,
    -625,  -625,  -625,  -625,  -625,  -625,  1574,  1605,  1577,  1611,
    1612,  1621,  1578,  -625,  -625,  -625,  -625,  -625,  -625,  -625,
    -625,  1579,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,
    -625,  1218,  -625,  1580,  -625,  1581,  1582,  1583,  -625,  1584,
    -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  1585,  1586,
    -625,  -625,  -625,  1587,  1588,  1589,  -625,  -625,  -625,  -625,
    -625,  -625,  1324,  1325,  1326,  1327,  1328,  1329,  1330,  1331,
    1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,  1341,
    1342,  1343,  1344,  1345,  1346,  -636,  1590,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1606,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,
    -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,
    -636,  -636,  -636,  -636,  1607,  1608,  1609,  1610,  1613,  1620,
    -636,  1622,  1623,  1624,  1625,  -636,  1626,  1627,  1628,  -636,
    -636,  1629,  -636,  -636,  -636,  -936,  -636,  1634,  1638,  1643,
    1644,  -636,  1645,  1647,  1648,  -604,  1659,  1686,  1651,  1652,
    1653,  1654,  1655,  1660,  1665,  1668,  1669,  1670,  1673,  1674,
    1675,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  1678,  1679,  1680,  1683,  1684,  1685,
    1688,  1687,  1690,  1692,  1694,  -604,  1696,  1724,  1708,  -604,
    -604,  1697,  -604,  -604,  -604,  -936,  -604,  1725,  1761,  1703,
    1726,  -604,  1727,  1728,  1758,  -608,  1773,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,  -608,  1743,  1744,  1745,  1746,  1747,  1748,
    1749,  1750,  1759,  1760,   502,  -608,  1767,  1770,  1242,  -608,
    -608,  1762,  -608,  -608,  -608,  1765,  -608,  1771,  1772,  1779,
    1774,  -608,   960,  1780,  1775,  -625,  1055,  1436,  1509,   962,
     944,  1512,  1513,  1764,  1710,  1633,   745,     0,  1769,     0,
    1753,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,
    -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,
    -625,  -625,  -625,  -625,   747,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -625,     0,     0,     0,  -625,
    -625,     1,  -625,  -625,  -625,     0,  -625,     0,     0,     0,
       0,  -625,     0,     0,   -11,   -11,   -13,     2,     3,   -16,
     -18,   -20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     4,     0,
       5,     0,     6,     7,     8,     9,    10,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    11,     0,
       0,     0,     0,     0,     0,     0,     0,  1324,  1325,  1326,
    1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,
    1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,
       0,     0,     0,     0,     0,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    1691,     0,     0,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,     0,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,     0,     0,
       0,     0,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,     0,   191,   192,     0,     0,     0,     0,   193,
       0,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   207,   208,   209,     0,
       0,     0,     0,     0,  1324,  1325,  1326,  1327,  1328,  1329,
    1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,
    1340,  1341,  1342,  1343,  1344,  1345,  1346,     0,     0,     0,
       0,     0,     0,  1535,   210,   964,   965,   966,   967,   968,
       0,     0,   211,     0,   973,   974,   975,  1768,     0,   212,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,     0,
       0,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1536,
    1103,  1206,     0,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,   995,     0,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  -670,  -670,  1004,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,  1206,     0,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,   995,     0,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  -672,  -672,  1004,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,  1206,     0,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,   995,     0,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  -666,  -666,  1004,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,     0,     0,     0,     0,     0,  1013,  1104,  1324,  1325,
    1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,
    1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,
    1346,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,
    1110,  1786,  1111,  1112,  1113,  1537,  1538,     0,  1114,   580,
    1015,  1016,     0,     0,     0,     0,  1177,  1116,     0,   582,
       0,     0,     0,     0,  1206,     0,   964,   965,   966,   967,
     968,   969,   970,   971,   972,   973,   974,   975,     0,     0,
       0,     0,     0,     0,  1013,   976,   977,   978,   979,   980,
     981,   982,   983,     0,   984,   985,   986,   987,   988,   989,
     990,   991,   992,     0,   993,     0,   994,     0,     0,     0,
     995,     0,   996,   997,   998,   999,  1000,  1001,  1002,  1003,
    -673,  -673,  1004,  1005,  1006,     0,     0,     0,  1007,  1008,
    1009,  1010,  1011,  1012,  1014,     0,     0,     0,  1015,  1016,
       0,     0,  1017,     0,     0,     0,  -670,     0,     0,     0,
       0,     0,     0,     0,  1013,  1324,  1325,  1326,  1327,  1328,
    1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,
    1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,  1330,  1331,
    1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,  1341,
    1342,  1343,  1344,  1345,  1346,     0,  1693,     0,     0,     0,
       0,     0,     0,     0,  1014,     0,     0,     0,  1015,  1016,
       0,     0,  1017,     0,     0,     0,  -672,     0,     0,     0,
       0,     0,     0,     0,  1013,  1324,  1325,  1326,  1327,  1328,
    1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,
    1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1776,     0,     0,     0,
       0,     0,     0,     0,  1014,     0,     0,     0,  1015,  1016,
       0,     0,  1017,     0,     0,  1206,  -666,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,     0,
       0,     0,     0,     0,     0,     0,   976,   977,   978,   979,
     980,   981,   982,   983,     0,   984,   985,   986,   987,   988,
     989,   990,   991,   992,     0,   993,     0,   994,     0,     0,
       0,   995,     0,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  -667,  -667,  1004,  1005,  1006,     0,     0,     0,  1007,
    1008,  1009,  1010,  1011,  1012,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1013,  1326,  1327,
    1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
    1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,  1327,
    1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
    1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,     0,
       0,     0,     0,     0,     0,     0,     0,  1014,     0,     0,
       0,  1015,  1016,     0,     0,  1017,     0,     0,  1206,  -673,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,   995,     0,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1206,     0,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,   995,     0,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1206,     0,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,     0,     0,     0,     0,     0,     0,  1013,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,   995,     0,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1014,     0,
       0,     0,  1015,  1016,     0,     0,  1017,     0,     0,  1206,
    -667,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,     0,     0,     0,     0,     0,     0,     0,
     976,   977,   978,   979,   980,   981,   982,   983,     0,   984,
     985,   986,   987,   988,   989,   990,   991,   992,     0,   993,
       0,   994,     0,     0,     0,   995,     0,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,
       0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,  1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,
    1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,
    1346,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1014,     0,     0,     0,  1015,  1016,     0,     0,  1017,
       0,     0,     0,  1207,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1014,     0,     0,     0,  1015,  1016,     0,     0,  1017,
       0,     0,     0,  1229,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1014,     0,     0,     0,  1015,  1016,     0,     0,  1017,
       0,     0,  1206,  1231,   964,   965,   966,   967,   968,   969,
     970,   971,   972,   973,   974,   975,     0,     0,     0,     0,
       0,     0,  1013,   976,   977,   978,   979,   980,   981,   982,
     983,     0,   984,   985,   986,   987,   988,   989,   990,   991,
     992,     0,   993,     0,   994,     0,     0,     0,   995,     0,
     996,   997,   998,   999,  1000,  1001,  1002,  1003,     0,     0,
    1004,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,
    1011,  1012,  1014,     0,     0,     0,  1015,  1016,     0,     0,
    1017,     0,     0,  1206,  1233,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,   995,
       0,   996,   997,   998,   999,  1000,  1001,  1002,  1003,     0,
       0,  1004,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1206,     0,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,   995,
       0,   996,   997,   998,   999,  1000,  1001,  1002,  1003,     0,
       0,  1004,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1206,     0,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,   995,
       0,   996,   997,   998,   999,  1000,  1001,  1002,  1003,     0,
       0,  1004,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1013,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1014,     0,     0,     0,  1015,
    1016,     0,     0,  1017,     0,     0,  1206,  1239,   964,   965,
     966,   967,   968,   969,   970,   971,   972,   973,   974,   975,
       0,     0,     0,     0,     0,     0,  1013,   976,   977,   978,
     979,   980,   981,   982,   983,     0,   984,   985,   986,   987,
     988,   989,   990,   991,   992,     0,   993,     0,   994,     0,
       0,     0,   995,     0,   996,   997,   998,   999,  1000,  1001,
    1002,  1003,     0,     0,  1004,  1005,  1006,     0,     0,     0,
    1007,  1008,  1009,  1010,  1011,  1012,  1014,     0,     0,     0,
    1015,  1016,     0,     0,  1017,     0,     0,     0,  1527,     0,
       0,     0,     0,     0,     0,     0,  1013,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1014,     0,     0,     0,
    1015,  1016,     0,     0,  1017,     0,     0,     0,  1646,     0,
       0,     0,     0,     0,     0,     0,  1013,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1014,     0,     0,     0,
    1015,  1016,     0,     0,  1017,     0,     0,  1206,  1656,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,   995,     0,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,     0,
       0,  1007,  1008,  1009,  1010,  1011,  1012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1013,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1014,
       0,     0,     0,  1015,  1016,     0,     0,  1017,     0,     0,
    1206,  1698,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,   995,     0,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1206,     0,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,   995,     0,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1206,     0,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,     0,     0,     0,     0,     0,     0,
    1013,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,   995,     0,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1014,     0,     0,     0,  1015,  1016,     0,     0,  1017,     0,
       0,     0,  1718,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1498,     0,   964,   965,   966,   967,   968,     0,     0,     0,
       0,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,     0,     0,   996,   997,
     998,   999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,
    1006,     0,     0,  1013,  1007,  1008,  1009,  1010,  1011,  1012,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1499,  1500,
    1501,  1502,  1503,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1014,     0,     0,     0,  1015,  1016,     0,
       0,  1017,     0,     0,     0,  1719,     0,     0,     0,     0,
       0,     0,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1014,     0,     0,     0,  1015,  1016,     0,
       0,  1017,     0,     0,     0,  1720,     0,     0,     0,     0,
       0,     0,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1014,     0,     0,     0,  1015,  1016,     0,
       0,  1017,     0,     0,     0,  1721,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1105,  1505,
       0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,
    1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,
       0,     0,     0,  1177,  1116,  1508,     0,   964,   965,   966,
     967,   968,     0,     0,     0,     0,   973,   974,   975,     0,
       0,     0,     0,     0,     0,     0,   976,   977,   978,   979,
     980,   981,   982,   983,     0,   984,   985,   986,   987,   988,
     989,   990,   991,   992,     0,   993,     0,   994,     0,     0,
       0,     0,     0,   996,   997,   998,   999,  1000,  1001,  1002,
       0,     0,     0,     0,  1005,  1006,     0,     0,     0,  1007,
    1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1499,  1500,  1501,  1502,  1503,  1504,  1300,
       0,   964,   965,   966,   967,   968,     0,     0,     0,     0,
     973,   974,   975,     0,     0,     0,     0,     0,     0,     0,
     976,   977,   978,   979,   980,   981,   982,   983,     0,   984,
     985,   986,   987,   988,   989,   990,   991,   992,     0,   993,
       0,   994,     0,     0,     0,     0,     0,   996,   997,   998,
     999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,
       0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1300,     0,   964,
     965,   966,   967,   968,     0,     0,     0,     0,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,     0,     0,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,     0,
       0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1013,  1104,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1105,  1505,     0,     0,  1106,     0,  1107,
    1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,
    1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1013,  1104,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1105,     0,     0,
       0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,
    1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,
       0,  1301,  1177,  1116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1013,  1104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,  1106,
       0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,
    1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,  1349,
    1177,  1116,  1300,     0,   964,   965,   966,   967,   968,     0,
       0,     0,     0,   973,   974,   975,     0,     0,     0,     0,
       0,     0,     0,   976,   977,   978,   979,   980,   981,   982,
     983,     0,   984,   985,   986,   987,   988,   989,   990,   991,
     992,     0,   993,     0,   994,     0,     0,     0,     0,     0,
     996,   997,   998,   999,  1000,  1001,  1002,     0,     0,     0,
       0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,
    1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
    1704,     0,   964,   965,   966,   967,   968,     0,     0,     0,
       0,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,     0,     0,   996,   997,
     998,   999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1189,     0,
     964,   965,   966,   967,   968,     0,     0,     0,     0,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,     0,     0,   996,   997,   998,   999,
    1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,
    1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,
    1098,  1099,  1100,  1101,  1102,  1103,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1013,  1104,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,
       0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,
    1016,     0,     0,     0,  1350,  1177,  1116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1105,     0,
    1705,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,
    1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,
       0,     0,     0,  1177,  1116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,  1104,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1105,     0,     0,     0,
    1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,
     541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,
       0,  1177,  1116,  1291,     0,   964,   965,   966,   967,   968,
       0,     0,     0,     0,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,     0,
       0,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1293,     0,   964,   965,   966,   967,   968,     0,     0,
       0,     0,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,     0,     0,   996,
     997,   998,   999,  1000,  1001,  1002,     0,     0,     0,     0,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1295,
       0,   964,   965,   966,   967,   968,     0,     0,     0,     0,
     973,   974,   975,     0,     0,     0,     0,     0,     0,     0,
     976,   977,   978,   979,   980,   981,   982,   983,     0,   984,
     985,   986,   987,   988,   989,   990,   991,   992,     0,   993,
       0,   994,     0,     0,     0,     0,     0,   996,   997,   998,
     999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,
       0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1013,  1104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,
    1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,
    1015,  1016,     0,     0,     0,     0,  1177,  1116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1013,  1104,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1105,
       0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,
    1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,
       0,     0,     0,     0,  1177,  1116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1013,  1104,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1105,     0,     0,
       0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,
    1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,
       0,     0,  1177,  1116,  1322,     0,   964,   965,   966,   967,
     968,     0,     0,     0,     0,   973,   974,   975,     0,     0,
       0,     0,     0,     0,     0,   976,   977,   978,   979,   980,
     981,   982,   983,     0,   984,   985,   986,   987,   988,   989,
     990,   991,   992,     0,   993,     0,   994,     0,     0,     0,
       0,     0,   996,   997,   998,   999,  1000,  1001,  1002,     0,
       0,     0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,
    1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,
    1102,  1103,  1356,     0,   964,   965,   966,   967,   968,     0,
       0,     0,     0,   973,   974,   975,     0,     0,     0,     0,
       0,     0,     0,   976,   977,   978,   979,   980,   981,   982,
     983,     0,   984,   985,   986,   987,   988,   989,   990,   991,
     992,     0,   993,     0,   994,     0,     0,     0,     0,     0,
     996,   997,   998,   999,  1000,  1001,  1002,     0,     0,     0,
       0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,
    1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
    1300,     0,   964,   965,   966,   967,   968,     0,     0,     0,
       0,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,     0,     0,   996,   997,
     998,   999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1013,  1104,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,
    1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,
       0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1013,  1104,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,
       0,  1111,  1112,  1113,   541,  1357,     0,  1114,     0,  1015,
    1016,     0,     0,     0,     0,  1177,  1116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1105,     0,
       0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,
    1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,
       0,     0,     0,  1177,  1116,  1495,     0,   964,   965,   966,
     967,   968,     0,     0,     0,     0,   973,   974,   975,     0,
       0,     0,     0,     0,     0,     0,   976,   977,   978,   979,
     980,   981,   982,   983,     0,   984,   985,   986,   987,   988,
     989,   990,   991,   992,     0,   993,     0,   994,     0,     0,
       0,     0,     0,   996,   997,   998,   999,  1000,  1001,  1002,
       0,     0,     0,     0,  1005,  1006,     0,     0,     0,  1007,
    1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1517,     0,   964,   965,   966,   967,   968,
       0,     0,     0,     0,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,     0,
       0,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1519,     0,   964,   965,   966,   967,   968,     0,     0,
       0,     0,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,     0,     0,   996,
     997,   998,   999,  1000,  1001,  1002,     0,     0,     0,     0,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1013,  1104,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1105,     0,     0,     0,  1106,     0,  1107,
    1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1496,     0,
    1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1013,  1104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,
    1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,
    1015,  1016,     0,     0,     0,     0,  1177,  1116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1013,  1104,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1105,
       0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,
    1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,
       0,     0,     0,     0,  1177,  1116,  1521,     0,   964,   965,
     966,   967,   968,     0,     0,     0,     0,   973,   974,   975,
       0,     0,     0,     0,     0,     0,     0,   976,   977,   978,
     979,   980,   981,   982,   983,     0,   984,   985,   986,   987,
     988,   989,   990,   991,   992,     0,   993,     0,   994,     0,
       0,     0,     0,     0,   996,   997,   998,   999,  1000,  1001,
    1002,     0,     0,     0,     0,  1005,  1006,     0,     0,     0,
    1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1103,  1528,     0,   964,   965,   966,   967,
     968,     0,     0,     0,     0,   973,   974,   975,     0,     0,
       0,     0,     0,     0,     0,   976,   977,   978,   979,   980,
     981,   982,   983,     0,   984,   985,   986,   987,   988,   989,
     990,   991,   992,     0,   993,     0,   994,     0,     0,     0,
       0,     0,   996,   997,   998,   999,  1000,  1001,  1002,     0,
       0,     0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,
    1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,
    1529,  1103,  1531,     0,   964,   965,   966,   967,   968,     0,
       0,     0,     0,   973,   974,   975,     0,     0,     0,     0,
       0,     0,     0,   976,   977,   978,   979,   980,   981,   982,
     983,     0,   984,   985,   986,   987,   988,   989,   990,   991,
     992,     0,   993,     0,   994,     0,     0,     0,     0,     0,
     996,   997,   998,   999,  1000,  1001,  1002,     0,     0,     0,
       0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,
    1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1013,
    1104,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1105,     0,     0,     0,  1106,     0,
    1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,
       0,  1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,
    1116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1013,  1104,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,
    1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,
       0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1013,  1104,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,
       0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,
    1016,     0,     0,     0,     0,  1177,  1116,  1533,     0,   964,
     965,   966,   967,   968,     0,     0,     0,     0,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,     0,     0,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,     0,
       0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1544,     0,   964,   965,   966,
     967,   968,     0,     0,     0,     0,   973,   974,   975,     0,
       0,     0,     0,     0,     0,     0,   976,   977,   978,   979,
     980,   981,   982,   983,     0,   984,   985,   986,   987,   988,
     989,   990,   991,   992,     0,   993,     0,   994,     0,     0,
       0,     0,     0,   996,   997,   998,   999,  1000,  1001,  1002,
       0,     0,     0,     0,  1005,  1006,     0,     0,     0,  1007,
    1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1546,     0,   964,   965,   966,   967,   968,
       0,     0,     0,     0,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,     0,
       0,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1013,  1104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,  1106,
       0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,
    1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,     0,
    1177,  1116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1013,  1104,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1105,     0,     0,     0,  1106,     0,  1107,
    1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,
    1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1013,  1104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,
    1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,
    1015,  1016,     0,     0,     0,     0,  1177,  1116,  1548,     0,
     964,   965,   966,   967,   968,     0,     0,     0,     0,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,     0,     0,   996,   997,   998,   999,
    1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,
    1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,
    1098,  1099,  1100,  1101,  1102,  1103,  1550,     0,   964,   965,
     966,   967,   968,     0,     0,     0,     0,   973,   974,   975,
       0,     0,     0,     0,     0,     0,     0,   976,   977,   978,
     979,   980,   981,   982,   983,     0,   984,   985,   986,   987,
     988,   989,   990,   991,   992,     0,   993,     0,   994,     0,
       0,     0,     0,     0,   996,   997,   998,   999,  1000,  1001,
    1002,     0,     0,     0,     0,  1005,  1006,     0,     0,     0,
    1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1103,  1555,     0,   964,   965,   966,   967,
     968,     0,     0,     0,     0,   973,   974,   975,     0,     0,
       0,     0,     0,     0,     0,   976,   977,   978,   979,   980,
     981,   982,   983,     0,   984,   985,   986,   987,   988,   989,
     990,   991,   992,     0,   993,     0,   994,     0,     0,     0,
       0,     0,   996,   997,   998,   999,  1000,  1001,  1002,     0,
       0,     0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,
    1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,
    1102,  1103,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,  1104,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1105,     0,     0,     0,
    1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,
     541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,
       0,  1177,  1116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1013,
    1104,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1105,     0,     0,     0,  1106,     0,
    1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,
       0,  1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,
    1116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1013,  1104,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,
    1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,
       0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,  1557,
       0,   964,   965,   966,   967,   968,     0,     0,     0,     0,
     973,   974,   975,     0,     0,     0,     0,     0,     0,     0,
     976,   977,   978,   979,   980,   981,   982,   983,     0,   984,
     985,   986,   987,   988,   989,   990,   991,   992,     0,   993,
       0,   994,     0,     0,     0,     0,     0,   996,   997,   998,
     999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,
       0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1559,     0,   964,
     965,   966,   967,   968,     0,     0,     0,     0,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,     0,     0,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,     0,
       0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1561,     0,   964,   965,   966,
     967,   968,     0,     0,     0,     0,   973,   974,   975,     0,
       0,     0,     0,     0,     0,     0,   976,   977,   978,   979,
     980,   981,   982,   983,     0,   984,   985,   986,   987,   988,
     989,   990,   991,   992,     0,   993,     0,   994,     0,     0,
       0,     0,     0,   996,   997,   998,   999,  1000,  1001,  1002,
       0,     0,     0,     0,  1005,  1006,     0,     0,     0,  1007,
    1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1013,  1104,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1105,     0,     0,
       0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,
    1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,
       0,     0,  1177,  1116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1013,  1104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,  1106,
       0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,
    1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,     0,
    1177,  1116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1013,  1104,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1105,     0,     0,     0,  1106,     0,  1107,
    1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,
    1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,
    1563,     0,   964,   965,   966,   967,   968,     0,     0,     0,
       0,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,     0,     0,   996,   997,
     998,   999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1565,     0,
     964,   965,   966,   967,   968,     0,     0,     0,     0,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,     0,     0,   996,   997,   998,   999,
    1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,
    1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,
    1098,  1099,  1100,  1101,  1102,  1103,  1567,     0,   964,   965,
     966,   967,   968,     0,     0,     0,     0,   973,   974,   975,
       0,     0,     0,     0,     0,     0,     0,   976,   977,   978,
     979,   980,   981,   982,   983,     0,   984,   985,   986,   987,
     988,   989,   990,   991,   992,     0,   993,     0,   994,     0,
       0,     0,     0,     0,   996,   997,   998,   999,  1000,  1001,
    1002,     0,     0,     0,     0,  1005,  1006,     0,     0,     0,
    1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1105,     0,
       0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,
    1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,
       0,     0,     0,  1177,  1116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,  1104,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1105,     0,     0,     0,
    1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,
     541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,
       0,  1177,  1116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1013,
    1104,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1105,     0,     0,     0,  1106,     0,
    1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,
       0,  1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,
    1116,  1763,     0,   964,   965,   966,   967,   968,     0,     0,
       0,     0,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,     0,     0,   996,
     997,   998,   999,  1000,  1001,  1002,     0,     0,     0,     0,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,   964,
     965,   966,   967,   968,     0,     0,     0,     0,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,     0,     0,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,     0,
       0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,   964,   965,   966,   967,   968,
       0,     0,     0,     0,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,     0,
       0,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1013,  1104,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1105,
       0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,
    1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,
       0,     0,     0,     0,  1177,  1116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1013,  1104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,  1106,
       0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,
    1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,     0,
    1115,  1116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1013,  1104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,
    1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,
    1015,  1016,     0,     0,     0,     0,  1136,  1116,   964,   965,
     966,   967,   968,     0,     0,     0,     0,   973,   974,   975,
       0,     0,     0,     0,     0,     0,     0,   976,   977,   978,
     979,   980,   981,   982,   983,     0,   984,   985,   986,   987,
     988,   989,   990,   991,   992,     0,   993,     0,   994,     0,
       0,     0,     0,     0,   996,   997,   998,   999,  1000,  1001,
    1002,     0,     0,     0,     0,  1005,  1006,     0,     0,     0,
    1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1103,   964,   965,   966,   967,   968,     0,
       0,     0,     0,   973,   974,   975,     0,     0,     0,     0,
       0,     0,     0,   976,   977,   978,   979,   980,   981,   982,
     983,     0,   984,   985,   986,   987,   988,   989,   990,   991,
     992,     0,   993,     0,   994,     0,     0,     0,     0,     0,
     996,   997,   998,   999,  1000,  1001,  1002,     0,     0,     0,
       0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,
    1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,   995,     0,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,     0,   964,
     965,   966,   967,   968,     0,     0,     0,     0,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,     0,     0,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,  1013,
    1104,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1105,     0,     0,     0,  1106,     0,
    1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,
       0,  1114,     0,  1015,  1016,     0,     0,     0,     0,  1138,
    1116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1013,  1104,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,
       0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,
    1016,     0,     0,     0,     0,  1177,  1116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1324,  1325,  1326,
    1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,
    1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1014,     0,     0,     0,  1015,  1016,     0,     0,  1017,
       0,     0,  1393,     0,     0,     0,     0,     0,     0,     0,
    1013,  1104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,  1106,
       0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,  1711,
    1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,     0,
    1177,  1116,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,   995,     0,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1308,     0,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,   995,     0,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,   995,     0,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1014,     0,     0,     0,  1015,  1016,     0,
       0,  1017,     0,     0,  1393,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1014,     0,     0,     0,  1015,  1016,     0,
       0,  1017,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1014,     0,     0,     0,  1015,  1016,     0,     0,  1017
};

static const yytype_int16 yycheck[] =
{
     238,   206,   437,   241,   237,   921,     1,  1243,   924,  1191,
       1,   927,     1,  1077,   930,  1079,  1098,  1081,  1100,  1083,
    1102,  1085,   938,     1,     1,     1,     1,     1,     1,   267,
     256,   269,  1019,   271,     1,   273,   924,   921,  1120,   927,
     924,     1,   930,   927,     1,     1,   930,     1,     1,  1036,
     938,  1038,     1,  1040,   938,     1,     1,  1044,   111,   112,
      57,    58,     1,   349,  1118,   354,     1,   356,  1122,   921,
       1,  1126,   924,    62,   339,   927,     1,  1115,   930,     1,
       1,   367,    57,    58,   319,     1,   938,   339,   353,     1,
     361,   356,   363,   358,     1,    62,   334,     1,  1136,     1,
    1138,   353,     1,  1019,     1,     1,     1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     1,   111,   112,
    1036,     1,  1038,     1,  1040,     1,     1,   319,  1044,     1,
       1,     1,     1,     1,   319,  1019,     1,    62,     1,  1177,
       1,     1,   340,     1,     1,     1,   581,     1,     1,   387,
     388,   389,  1036,   319,  1038,   353,  1040,     1,   353,     1,
    1044,   356,   319,     1,     1,     1,     1,  1019,     1,     1,
       1,     1,     1,    89,    90,    91,    92,     1,   110,   111,
     112,     1,   420,   421,  1036,     1,  1038,     1,  1040,     1,
      62,  1178,  1044,     1,     1,     1,     1,    14,    15,  1115,
    1116,     1,   319,     1,  1191,    89,    90,    91,    92,     1,
     951,   952,     1,   339,     1,   319,     1,     1,   319,   319,
    1136,     1,  1138,   349,    89,    90,    91,    92,  1116,     1,
       1,  1115,  1116,   319,   472,     1,     1,   475,   476,   919,
     319,     1,     1,   923,   319,     1,   926,   319,     1,   929,
       1,     1,  1136,     1,  1138,     1,  1320,     1,   319,     1,
       1,  1177,  1178,  1115,  1116,     1,     1,     1,     1,     1,
      62,     1,     1,     1,     1,  1191,     1,   361,     1,   363,
       1,     1,     1,     1,  1136,     1,  1138,     1,     1,     1,
       1,     1,     1,  1177,  1178,     1,     1,   353,   354,   339,
     356,     1,     1,   921,     1,   319,   924,  1191,     1,   927,
    1226,     1,   930,   353,   319,     1,   356,   370,     1,   319,
     938,     1,  1309,     1,  1240,  1177,  1178,     1,     1,   921,
       1,     1,   924,     1,  1250,   927,   319,   339,   930,  1191,
       1,   319,  1226,     1,     0,   319,   938,   349,     1,     1,
       1,     1,  1240,     1,     1,     1,  1240,     1,     1,     1,
     586,     1,  1250,   339,   353,   354,  1250,   356,   357,   366,
     365,  1426,   367,   365,   363,  1611,   367,   353,   367,     1,
     353,   354,   355,   356,   357,   362,   353,   354,  1240,   356,
     357,   366,     1,  1309,   367,     1,   353,   353,  1250,   353,
     367,  1019,     1,   357,   357,   365,   363,   353,   354,   355,
     356,   357,   319,   367,   367,   354,   365,   356,  1036,   364,
    1038,   367,  1040,  1605,   340,  1309,  1044,  1019,   353,   354,
     365,   356,   357,   354,   365,   356,   367,   353,   354,   355,
     356,   357,   367,   365,  1036,   367,  1038,  1529,  1040,   356,
    1437,   367,  1044,   365,  1536,   367,   340,  1309,   353,   354,
    1447,   365,   364,   367,   363,   364,     1,   364,   364,   353,
     354,   355,   356,   357,   354,   340,   356,  1393,   354,   354,
     364,   353,   354,   367,   356,   357,   364,   356,   353,   354,
     355,   356,   357,   364,   364,   367,   364,  1115,  1116,   364,
       1,   364,   367,   364,   364,  1393,   364,   364,   364,  1393,
     364,   364,   356,   948,  1430,  1431,  1432,  1433,  1136,   304,
    1138,  1437,   364,   356,  1116,  1761,   364,   364,   364,   364,
     319,  1447,   364,   364,   364,   364,   356,   353,   354,   355,
     364,  1393,  1430,  1431,  1432,  1433,  1430,  1431,  1432,  1433,
     364,   356,   364,  1437,   354,     1,   364,   364,   364,  1177,
    1178,   353,   354,  1447,   356,   357,   364,   356,   339,   356,
     354,   356,   356,  1191,   359,   367,   356,    63,  1430,  1431,
    1432,  1433,   353,     1,   356,  1437,  1178,     1,   354,   354,
     356,   356,   363,     1,   354,  1447,   356,   356,   354,  1191,
     356,   354,   353,   356,   354,   356,   356,   353,   356,     1,
     356,     1,   356,  1048,   356,   356,     1,  1604,  1605,   353,
     356,   356,  1240,   356,   356,     1,   356,   356,   356,   356,
    1694,   356,  1250,   356,  1226,   356,   356,   356,   356,     1,
     356,     1,   356,   356,   356,   356,   356,   356,  1240,   339,
     356,   356,  1639,  1640,  1641,  1642,   356,   356,  1250,   356,
     353,   354,   355,   353,     1,   339,   339,   353,   339,   339,
     353,   339,     1,   353,     1,   353,     1,     1,   339,   353,
     353,   339,   353,   353,     1,   353,   339,   339,  1604,  1605,
     340,  1309,   353,   339,     1,   353,   339,   339,   319,   339,
     353,   353,   353,   353,     1,   353,   353,   353,     1,   353,
     353,   353,   917,   353,     1,     1,     1,  1309,   340,     1,
    1604,  1605,     1,  1639,  1640,  1641,  1642,     1,     1,     1,
     339,   353,     1,   339,     1,     1,     1,     1,     1,     1,
     339,     1,     1,     1,   353,  1180,     1,   353,     1,  1184,
       1,     1,  1604,  1605,   353,  1639,  1640,  1641,  1642,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,  1393,     1,     1,     1,  1766,
       1,     1,     1,     1,     1,   319,     1,  1639,  1640,  1641,
    1642,  1778,  1708,     1,     1,  1782,   319,  1784,  1785,     1,
       1,  1393,     1,     1,   339,   319,     1,     1,   319,     1,
      58,     1,  1430,  1431,  1432,  1433,     1,     1,   353,  1437,
    1708,     1,     1,     1,  1708,     1,     1,     1,     1,  1447,
       1,     1,     1,     1,   361,     1,   363,     1,  1430,  1431,
    1432,  1433,     1,     1,     1,  1437,  1762,     1,     1,  1765,
    1766,     1,   353,     1,     1,  1447,  1708,   319,     1,     1,
       1,   319,  1778,  1779,  1780,     1,  1782,   353,  1784,  1785,
       1,   339,   319,     1,  1762,   319,     1,  1765,  1762,     1,
     921,  1765,  1766,   924,     1,   353,   927,   319,   356,   930,
       1,  1779,  1780,   339,  1778,  1779,  1780,   938,  1782,     1,
    1784,  1785,   319,   969,   970,   971,     1,   353,     1,     1,
    1762,     1,     1,  1765,  1766,   319,   319,    63,     1,     1,
       1,   339,   319,    63,  1162,   319,  1778,  1779,  1780,   995,
    1782,     1,  1784,  1785,   349,   353,    63,  1003,  1004,   353,
    1079,   319,  1081,  1176,  1083,   353,  1085,     1,     1,     1,
     319,  1184,     1,    89,    90,    91,    92,     1,    63,    16,
     339,   353,   319,   353,    89,    90,    91,    92,   353,     1,
     349,   339,     1,   319,     1,   327,   328,   353,  1019,   319,
     332,   333,   361,    19,   363,   353,  1604,  1605,     1,     1,
     319,   353,  1197,   353,  1199,  1036,  1201,  1038,   319,  1040,
     368,   319,     1,  1044,   338,   339,   340,   341,   342,   339,
    1248,  1249,  1604,  1605,     1,   319,   353,     1,     1,   349,
       1,  1639,  1640,  1641,  1642,   361,   353,   363,   353,   353,
     361,   361,   363,   363,   319,     1,   353,   353,   354,   361,
     356,   363,  1108,  1109,  1110,    20,   353,  1639,  1640,  1641,
    1642,     1,     1,   327,   328,   329,   353,     1,   332,   333,
     353,     1,    21,   319,   327,   328,   353,   353,  1134,   332,
     333,   353,   319,   319,   353,  1116,   319,   353,   353,  1145,
     353,   353,   319,   361,   353,   363,   353,   353,   353,   353,
    1708,   353,   353,   353,   353,   353,   353,   354,   353,   356,
     353,   353,   353,   353,   353,   353,   354,   238,   239,   240,
     241,   353,   353,   353,   353,   353,  1708,   353,   353,   353,
     353,   353,   353,   353,   353,   353,   353,   319,   353,   353,
     353,   319,   353,   353,   353,   353,   353,  1178,   353,   319,
     319,   353,   319,   319,  1762,   353,   353,  1765,  1766,   353,
    1191,   353,   353,   319,   353,   353,   319,  1223,   353,   353,
    1778,  1779,  1780,   353,  1782,   319,  1784,  1785,   353,   353,
    1762,   353,   353,  1765,  1766,   353,   365,  1612,   353,   353,
     353,  1320,   353,   353,   353,   353,  1778,  1779,  1780,   353,
    1782,   319,  1784,  1785,   353,   353,   353,   319,   319,  1240,
     353,   319,   319,   353,   340,   353,   353,   353,   319,  1250,
     353,   353,   353,   353,   353,   340,   361,   319,   363,  1285,
    1286,  1287,   319,   361,   319,   363,   353,   319,   319,   319,
     319,  1297,  1298,  1299,   327,   328,   319,   319,   319,   332,
     333,   334,   335,   336,   337,  1311,   319,   319,   353,   319,
     319,  1317,  1318,   319,  1320,   340,   341,   342,  1324,  1325,
    1326,  1327,  1328,  1329,  1330,   319,   319,   319,  1309,   319,
     319,   319,    89,    90,    91,    92,  1342,  1343,  1344,  1345,
    1346,  1347,  1348,   327,   328,   329,   319,   319,   332,   333,
     319,     1,   319,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,  1543,   319,   319,   353,   354,
     319,   356,    22,    23,    24,    25,    26,    27,    28,    29,
     319,    31,    32,    33,    34,    35,    36,    37,    38,    39,
     319,    41,   319,    43,   319,   319,   319,    47,   319,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,  1393,   353,  1420,    65,    66,    67,    68,    69,
      70,   327,   328,   329,     1,   319,   332,   333,   319,   319,
     319,   285,   286,   287,   288,   319,   290,   353,   356,   319,
     306,   307,   308,   309,   310,   311,   312,   313,   314,  1430,
    1431,  1432,  1433,   339,   339,   319,  1437,   339,   353,   354,
     355,   356,   357,   349,   349,   353,  1447,   349,   361,   364,
     363,   319,   367,   319,   319,   361,   361,   363,   363,   361,
     361,   363,   363,   361,   361,   363,   363,   361,   354,   363,
    1635,   319,   361,  1638,   363,    72,    73,    74,    75,   361,
      77,   363,    79,   361,    81,   363,   319,   319,  1686,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   365,   319,   319,   353,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   319,   319,   340,   319,   319,   319,   319,   353,   354,
     355,   356,   357,   319,   319,   319,   353,   354,   355,   356,
     357,   363,   367,   319,   319,   319,   319,   364,   319,  1615,
     367,   319,   319,   319,   319,  1621,   319,   319,   319,   319,
     319,   319,   319,  1604,  1605,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   319,   319,
     319,   319,   319,   319,   304,   319,   319,   319,  1639,  1640,
    1641,  1642,   319,   353,   319,   319,   319,   319,   363,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,  1693,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   319,   319,  1705,
     319,   319,   319,   319,   354,   319,   319,  1713,   358,   359,
     319,   319,   362,   319,     0,     1,   366,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,  1708,    14,    15,
      16,    17,    18,    19,    20,    21,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    38,   319,    40,   319,    42,    43,    44,    45,
      46,   319,   319,   319,   319,   319,   319,   319,   319,   319,
    1776,   319,    58,   319,   319,   319,   319,   319,   319,   319,
     353,  1762,   353,   353,  1765,  1766,   353,   356,   353,   361,
     353,   353,   353,   353,   353,   370,   370,  1778,  1779,  1780,
     368,  1782,   319,  1784,  1785,   319,   353,   356,   319,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   353,   353,   353,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     353,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   353,   353,   353,   353,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   353,   283,   284,   353,
     353,   353,   353,   289,   365,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   361,   365,
     365,   353,   353,   367,   349,   361,   361,   357,   370,   319,
     316,   317,   318,   353,   360,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   319,   319,
     368,   353,   361,   363,   368,   356,   368,   356,   354,   356,
     364,   364,   319,   368,   362,   349,   362,   349,   363,   111,
     364,   364,     1,   369,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   364,   364,   364,   364,
     364,   364,   364,    22,    23,    24,    25,    26,    27,    28,
      29,   362,    31,    32,    33,    34,    35,    36,    37,    38,
      39,   365,    41,   368,    43,   368,   368,   361,    47,   370,
      49,    50,    51,    52,    53,    54,    55,    56,   361,   365,
      59,    60,    61,   364,   364,   364,    65,    66,    67,    68,
      69,    70,     1,   356,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   363,   363,   363,   363,
     363,   363,   363,    22,    23,    24,    25,    26,    27,    28,
      29,   363,    31,    32,    33,    34,    35,    36,    37,    38,
      39,   363,    41,   364,    43,   349,   365,   367,    47,   365,
      49,    50,    51,    52,    53,    54,    55,    56,   365,   365,
      59,    60,    61,   282,   282,   353,    65,    66,    67,    68,
      69,    70,     1,   356,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   353,   363,   363,   363,
     363,   363,   354,    22,    23,    24,    25,    26,    27,    28,
      29,   366,    31,    32,    33,    34,    35,    36,    37,    38,
      39,   363,    41,   319,    43,   319,   319,   319,    47,   363,
      49,    50,    51,    52,    53,    54,    55,    56,   367,   363,
      59,    60,    61,   361,   363,   361,    65,    66,    67,    68,
      69,    70,     1,   363,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   363,    48,   363,   370,
     370,   361,   363,    22,    23,    24,    25,    26,    27,    28,
      29,   363,    31,    32,    33,    34,    35,    36,    37,    38,
      39,   354,    41,   363,    43,   363,   363,   363,    47,   363,
      49,    50,    51,    52,    53,    54,    55,    56,   363,   363,
      59,    60,    61,   363,   363,   363,    65,    66,    67,    68,
      69,    70,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   304,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   363,   363,   363,   363,   363,   363,
     349,   363,   363,   363,   363,   354,   363,   363,   363,   358,
     359,   363,   361,   362,   363,   364,   365,   368,   361,   356,
     356,   370,   319,   349,   111,   304,   353,   367,   363,   363,
     363,   363,   363,   353,   353,   353,   353,   353,   353,   353,
     353,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   353,   353,   353,   353,   353,   353,
     363,   349,   363,   363,   341,   354,   356,   353,   370,   358,
     359,   356,   361,   362,   363,   364,   365,   356,   370,   366,
     363,   370,   363,   363,   368,   304,   111,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   214,   354,   363,   363,  1048,   358,
     359,   370,   361,   362,   363,   370,   365,   363,   363,   370,
     368,   370,   915,   370,   368,   304,   946,  1238,  1287,   917,
     582,  1289,  1289,  1705,  1619,  1421,   394,    -1,  1713,    -1,
    1687,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   395,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,   358,
     359,     1,   361,   362,   363,    -1,   365,    -1,    -1,    -1,
      -1,   370,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     363,    -1,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
      -1,    -1,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,    -1,    -1,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   316,   317,   318,    -1,
      -1,    -1,    -1,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,    -1,    -1,
      -1,    -1,    -1,     1,   354,     3,     4,     5,     6,     7,
      -1,    -1,   362,    -1,    12,    13,    14,   363,    -1,   369,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,   304,   305,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,
     348,   363,   350,   351,   352,   353,   354,    -1,   356,   357,
     358,   359,    -1,    -1,    -1,    -1,   364,   365,    -1,   367,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,   304,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    65,    66,
      67,    68,    69,    70,   354,    -1,    -1,    -1,   358,   359,
      -1,    -1,   362,    -1,    -1,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   304,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   361,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,
      -1,    -1,   362,    -1,    -1,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   304,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   361,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,
      -1,    -1,   362,    -1,    -1,     1,   366,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,
      -1,    47,    -1,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    -1,    -1,    -1,    65,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,
      -1,   358,   359,    -1,    -1,   362,    -1,    -1,     1,   366,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   304,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,   354,    -1,
      -1,    -1,   358,   359,    -1,    -1,   362,    -1,    -1,     1,
     366,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      -1,    -1,    -1,    65,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362,
      -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362,
      -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362,
      -1,    -1,     1,   366,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   304,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    43,    -1,    -1,    -1,    47,    -1,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    -1,    -1,    -1,    65,    66,    67,    68,
      69,    70,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,
     362,    -1,    -1,     1,   366,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,   358,
     359,    -1,    -1,   362,    -1,    -1,     1,   366,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,   304,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    43,    -1,
      -1,    -1,    47,    -1,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    70,   354,    -1,    -1,    -1,
     358,   359,    -1,    -1,   362,    -1,    -1,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,
     358,   359,    -1,    -1,   362,    -1,    -1,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,
     358,   359,    -1,    -1,   362,    -1,    -1,     1,   366,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    -1,    -1,
      -1,    65,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   354,
      -1,    -1,    -1,   358,   359,    -1,    -1,   362,    -1,    -1,
       1,   366,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
     304,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
     354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362,    -1,
      -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,
      61,    -1,    -1,   304,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,    -1,
      -1,   362,    -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,    -1,
      -1,   362,    -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,    -1,
      -1,   362,    -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,   340,
      -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,    -1,   356,    -1,   358,   359,    -1,
      -1,    -1,    -1,   364,   365,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,
      -1,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   339,   340,    -1,    -1,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,    -1,
     356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,
      -1,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,
      -1,   363,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,   363,
     364,   365,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,    -1,   356,    -1,   358,
     359,    -1,    -1,    -1,   363,   364,   365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,
     341,    -1,   343,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,    -1,   356,    -1,   358,   359,    -1,
      -1,    -1,    -1,   364,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,
     343,    -1,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,
      -1,   364,   365,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,   359,    -1,    -1,    -1,    -1,   364,   365,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,
      -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,    -1,   356,    -1,   358,   359,
      -1,    -1,    -1,    -1,   364,   365,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,
      -1,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,
      -1,    -1,   364,   365,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,    -1,   356,
      -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,    -1,   356,    -1,   358,
     359,    -1,    -1,    -1,    -1,   364,   365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,
      -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,    -1,   356,    -1,   358,   359,    -1,
      -1,    -1,    -1,   364,   365,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,    -1,
     356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,   359,    -1,    -1,    -1,    -1,   364,   365,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,
      -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,    -1,   356,    -1,   358,   359,
      -1,    -1,    -1,    -1,   364,   365,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,
     305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
      -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,
     365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,    -1,   356,
      -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,    -1,   356,    -1,   358,
     359,    -1,    -1,    -1,    -1,   364,   365,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,
      -1,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,
     364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,    -1,
     356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,   359,    -1,    -1,    -1,    -1,   364,   365,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,
     343,    -1,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,
      -1,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,
     305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
      -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,
     365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,    -1,   356,
      -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,
      -1,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,
      -1,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,
      -1,    -1,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,
     364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,    -1,
     356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,
      -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,    -1,   356,    -1,   358,   359,    -1,
      -1,    -1,    -1,   364,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,
     343,    -1,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,
      -1,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,
     305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
      -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,
     365,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,
      -1,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,
      -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,    -1,   356,    -1,   358,   359,
      -1,    -1,    -1,    -1,   364,   365,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,
     364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,   359,    -1,    -1,    -1,    -1,   364,   365,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,   304,
     305,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
      -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,
     365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,    -1,   356,    -1,   358,
     359,    -1,    -1,    -1,    -1,   364,   365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362,
      -1,    -1,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,
     364,   365,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,    -1,
      -1,   362,    -1,    -1,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,    -1,
      -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     1,    17,    18,    38,    40,    42,    43,    44,    45,
      46,    58,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   283,   284,   289,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   316,   317,   318,
     354,   362,   369,   372,   373,   374,   375,   376,   377,   378,
     379,   390,   394,   397,   398,   400,   401,   411,   412,   421,
     319,     1,   367,     1,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
       1,   356,     1,   356,     1,   319,   356,     1,   364,     1,
     364,     1,   319,   356,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,     1,   319,
       1,   319,     1,   319,     1,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,     1,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   349,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,     1,   354,   356,   391,   392,   393,
       1,   393,   395,   396,     1,   356,     1,   356,     1,   356,
       0,     1,   374,    14,    15,   407,   408,    16,   409,   410,
      19,   415,   416,    20,   417,   418,    21,   419,   420,   349,
     367,   365,   353,   354,   356,   406,     1,   353,     1,   353,
       1,   353,     1,    89,    90,    91,    92,   340,   383,     1,
     339,   353,   389,     1,   353,     1,   353,     1,   389,     1,
     353,     1,   353,     1,   353,     1,   353,     1,   354,     1,
     356,     1,   353,     1,   356,     1,   353,     1,   356,     1,
     356,     1,   356,     1,   356,     1,   353,   354,   355,   356,
     357,   364,   367,   380,   382,   383,   387,   388,   402,   403,
     404,   405,   435,   436,     1,   388,     1,   353,     1,   353,
       1,   353,   353,   353,   353,   389,   389,   389,   389,   353,
     353,   353,   353,   353,   353,   353,   353,   353,   353,   353,
     353,   353,   353,   353,   353,   353,   353,   353,   353,   356,
     353,   353,   353,   353,   353,   353,   353,   353,   353,     1,
     389,     1,   353,     1,   356,     1,   353,     1,   353,     1,
     353,     1,   353,     1,   353,     1,   356,     1,   353,     1,
     353,     1,   389,     1,   389,     1,   389,     1,   389,     1,
     389,     1,   389,     1,   389,     1,   389,     1,   389,     1,
     389,     1,   353,     1,   353,     1,   356,     1,   356,     1,
     353,     1,   356,   356,   356,     1,   356,     1,   353,     1,
     353,     1,   354,   356,     1,   354,   356,     1,   354,   356,
       1,   354,   356,     1,   354,   356,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   353,     1,   353,     1,   389,
       1,   389,     1,   389,     1,   354,   356,     1,   353,     1,
     353,     1,   353,     1,   353,   403,     1,   405,     1,   353,
       1,   353,   353,   353,   353,   353,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   353,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   353,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   389,     1,   389,     1,   353,
       1,   353,     1,   353,     1,   353,     1,   238,   239,   240,
     241,     1,   353,     1,   353,     1,   353,     1,   353,     1,
     356,     1,   356,     1,   356,     1,   353,     1,   353,     1,
     353,     1,   380,     1,   353,     1,   353,     1,   353,     1,
     353,     1,   353,     1,   353,     1,   353,     1,   353,     1,
     353,     1,   353,     1,   353,     1,   353,     1,   353,     1,
     353,     1,   353,     1,   354,   356,     1,   353,   354,   353,
       1,   353,     1,   353,     1,   353,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   356,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   353,     1,   353,   285,   286,
     287,   288,   290,     1,   389,   353,   353,     1,   389,     1,
     389,     1,   353,     1,   353,     1,   353,     1,   353,     1,
     353,     1,   356,     1,   356,   361,   370,   361,     1,   367,
       1,   365,     1,   367,   365,     1,   367,   365,     1,   367,
     365,     1,   367,    58,   353,   354,   399,   353,   413,   368,
     353,   349,   380,   381,   404,   370,   370,   388,   110,   111,
     112,   339,   349,   361,   361,   319,   319,   319,   319,   319,
     391,   353,   395,   406,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    22,    23,    24,    25,
      26,    27,    28,    29,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    41,    43,    47,    49,    50,    51,    52,
      53,    54,    55,    56,    59,    60,    61,    65,    66,    67,
      68,    69,    70,   304,   354,   358,   359,   362,   437,   439,
     440,   441,   445,   446,   454,   455,   457,   458,   461,   462,
     464,   468,   469,   470,   474,   406,   439,   406,   439,   406,
     439,   360,   319,   368,   439,     1,   414,   353,   361,   363,
     368,     1,   340,   353,   385,   382,   380,   356,     1,   353,
     435,     1,   435,   356,   356,     1,   356,     1,   356,     1,
     356,     1,   356,     1,   356,   368,     1,   364,     1,   364,
       1,   364,     1,   364,     1,   364,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,   305,   339,   343,   345,   346,   347,
     348,   350,   351,   352,   356,   364,   365,   389,   427,   428,
     429,   430,   431,   432,   437,   449,   454,   455,   456,   457,
     459,   461,   462,   465,   466,   467,   364,   467,   364,   467,
       1,   364,     1,   364,     1,   364,   364,     1,   364,     1,
     364,     1,   364,     1,   364,     1,   364,     1,   364,     1,
     364,     1,   364,   364,     1,   364,     1,   364,     1,   364,
       1,   364,   364,   364,   364,   364,   364,   364,   467,     1,
     364,     1,   364,     1,   364,   364,   364,   364,   364,     1,
     467,   467,     1,   364,     1,   364,     1,   364,     1,   364,
       1,   364,     1,   471,     1,   362,     1,   366,   440,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   354,   451,
     452,   453,   319,   463,   362,     1,   364,   362,   368,   366,
     368,   366,   368,   366,   368,     1,   353,   356,   349,   366,
     365,   349,   381,   370,   111,   112,   370,   111,   361,   361,
     365,     1,    62,   354,   356,   363,   402,   434,     1,    62,
     356,   402,   434,     1,    62,   356,   402,   434,     1,    62,
     356,   402,   434,     1,    62,   356,   402,   434,     1,   327,
     328,   329,   332,   333,   422,   424,   422,   422,     1,   422,
     450,     1,   467,     1,   467,     1,   467,   364,   364,   364,
       1,   363,   455,   457,   461,   462,   467,   468,     1,   439,
       1,   424,     1,   334,   335,   336,   337,   422,   423,     1,
     424,   453,     1,   467,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   425,   426,   363,
     363,     1,   353,   356,     1,   356,     1,   354,   467,   356,
       1,   356,     1,   356,     1,   356,     1,   356,     1,   353,
       1,   353,   363,     1,   363,   389,   363,     1,   356,     1,
     356,     1,   356,     1,   356,   363,   363,   363,     1,   353,
     363,     1,   383,   365,   438,   440,     1,   380,     1,   353,
       1,   380,   383,   386,   363,   363,   363,   363,   365,   438,
       1,   356,     1,   356,   353,   393,   353,   393,   353,   393,
     364,   349,   367,   467,     1,   356,   454,   455,   460,   462,
     365,   365,   365,   365,   282,   282,   399,   439,   353,   385,
     356,   353,   356,   389,   356,   358,   389,   439,   363,   361,
     363,   361,   363,   361,   363,   339,   349,   361,   363,   363,
     361,   363,   361,   363,   361,   363,   361,   363,   363,   361,
     363,   361,   363,   361,   363,   361,   363,   363,   361,   363,
     361,   363,   361,   363,   361,   363,   363,   361,   363,   361,
     363,   361,   363,   361,   363,     1,   354,   467,     1,    89,
      90,    91,    92,    93,    94,   340,   384,   467,     1,   384,
     467,     1,   427,   431,   354,   447,   448,     1,   467,     1,
     467,     1,   467,   363,   363,   363,   366,   366,     1,    87,
     467,     1,   467,     1,   467,     1,    87,   353,   354,   402,
     433,   434,   467,   367,     1,   467,     1,   467,     1,   467,
       1,   467,   467,   467,   467,     1,   467,     1,   467,     1,
     467,     1,   467,     1,   467,     1,   467,     1,   467,   363,
     361,   363,   363,   361,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   439,    48,   363,   363,   363,   363,
     363,   370,   370,   363,     1,    57,    58,   366,   443,   444,
     363,   361,   363,   363,   363,   363,   363,   363,   363,   363,
     467,   472,   473,   452,   368,   361,   363,   453,   361,   439,
     439,   439,   439,   356,   356,   319,   366,   349,   111,   111,
     112,   363,   363,   363,   363,   363,   366,    63,   353,   353,
     353,     1,   354,     1,   354,   353,    63,   353,   353,   353,
     353,    63,   353,   353,   353,   353,    63,   353,   353,   353,
     353,    63,   353,   353,   353,   353,   367,   349,   363,   363,
     363,   363,   363,   361,   341,   389,   356,   356,   366,   438,
       1,   385,   380,   366,     1,   341,   442,   467,   370,   366,
     443,   353,   467,   361,   363,   393,     1,   393,   366,   366,
     366,   366,   353,   356,   353,   356,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   356,   389,   447,   467,     1,   353,   402,   368,   363,
     363,   370,   370,     1,   442,   370,   439,   363,   363,   473,
     363,   363,   363,   111,   368,   368,   361,   385,   439,   370,
     370,     1,   439,   467,   439,   439,   363
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   371,   372,   373,   373,   373,   374,   374,   374,   374,
     374,   375,   374,   376,   374,   374,   377,   374,   378,   374,
     379,   374,   374,   374,   380,   380,   380,   381,   381,   382,
     382,   383,   383,   383,   383,   383,   384,   384,   384,   384,
     384,   384,   384,   385,   385,   386,   386,   386,   386,   386,
     387,   387,   387,   387,   387,   388,   388,   389,   389,   390,
     390,   391,   391,   392,   392,   393,   393,   394,   394,   395,
     395,   396,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     398,   398,   399,   399,   399,   400,   400,   400,   400,   400,
     400,   400,   401,   401,   401,   401,   401,   401,   401,   401,
     401,   401,   401,   401,   401,   401,   401,   401,   401,   401,
     401,   402,   402,   403,   404,   405,   405,   406,   406,   406,
     407,   407,   408,   408,   408,   408,   409,   410,   410,   410,
     411,   411,   413,   412,   412,   412,   414,   412,   412,   415,
     416,   416,   416,   417,   418,   418,   418,   419,   420,   420,
     421,   421,   421,   421,   421,   421,   422,   422,   422,   422,
     423,   423,   423,   423,   424,   424,   425,   425,   425,   425,
     425,   425,   425,   426,   426,   426,   426,   427,   427,   427,
     428,   428,   428,   429,   429,   429,   429,   429,   430,   430,
     431,   431,   431,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   433,   433,   433,   433,   434,   434,   434,   434,
     434,   435,   435,   435,   436,   436,   436,   436,   436,   437,
     438,   438,   439,   439,   439,   440,   440,   440,   440,   440,
     440,   440,   440,   441,   441,   442,   443,   443,   443,   443,
     443,   443,   443,   443,   443,   443,   443,   444,   444,   445,
     445,   445,   445,   446,   447,   447,   447,   448,   448,   450,
     449,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     452,   453,   453,   454,   455,   456,   457,   458,   458,   459,
     459,   459,   460,   460,   460,   461,   462,   463,   464,   464,
     464,   465,   465,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   466,   466,   466,   467,   467,   467,   467,
     467,   467,   467,   467,   467,   467,   467,   467,   467,   467,
     467,   467,   467,   467,   467,   467,   467,   467,   467,   467,
     467,   467,   467,   467,   467,   467,   467,   467,   467,   467,
     467,   467,   467,   467,   467,   467,   467,   468,   469,   469,
     469,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   471,   470,   470,   472,
     472,   472,   473,   474,   474,   474,   474,   474,   474,   474,
     474,   474,   474
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     5,     3,
       1,     3,     3,     5,     3,     1,     2,     1,     2,     2,
       2,     1,     3,     1,     3,     1,     1,     2,     2,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     5,     6,     7,     8,     9,
      10,     5,     6,     7,     8,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     2,
       1,     1,     1,     1,     1,     5,     5,     7,     7,     5,
       8,     8,     2,     2,     2,     2,     2,     2,     3,     3,
       8,     8,     2,     8,     8,     8,     2,     2,     2,     3,
       3,     1,     1,     7,     1,     1,     3,     1,     1,     1,
       1,     1,     4,     7,     2,     2,     1,     4,     7,     2,
       1,     1,     0,     5,     2,     2,     0,     8,     5,     1,
       4,     7,     2,     1,     4,     7,     2,     1,     7,     2,
       2,     2,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     2,     3,     3,     3,
       2,     3,     3,     3,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     3,
       3,     2,     3,     3,     1,     3,     1,     3,     3,     3,
       3,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       1,     3,     2,     1,     2,     2,     1,     1,     1,     2,
       2,     1,     2,     3,     5,     1,     4,     5,     3,     4,
       3,     2,     4,     5,     3,     4,     4,     2,     1,     5,
       4,     2,     5,     3,     1,     4,     4,     3,     1,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     2,     5,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     1,     1,     1,     1,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     4,     2,     8,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     4,     4,     2,     3,     1,     1,
       1,     3,     4,     4,     4,     6,     6,     6,     6,     6,
       4,     2,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     4,     2,     4,     4,     4,     4,     6,     6,     6,
       6,     6,     4,     2,     4,     4,     4,     4,     6,     6,
       6,     6,     6,     4,     2,     4,     4,     4,     4,     6,
       6,     6,     6,     6,     4,     2,     4,     4,     6,     2,
       4,     4,     4,     2,     4,     4,     2,     4,     4,     2,
       6,     6,     6,     4,     2,     6,     2,     4,     4,     4,
       2,     4,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     4,     3,     2,     4,     3,     2,
       4,     3,     4,     2,     4,     4,     2,     4,     4,     2,
       4,     4,     2,     4,     4,     2,     4,     4,     2,     4,
       3,     1,     3,     1,     3,     1,     4,     3,     1,     4,
       4,     4,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     3,     1,     3,     1,     3,     1,     3,     1,     6,
       6,     2,     4,     4,     2,     4,     0,     5,     2,     0,
       3,     1,     1,     3,     2,     1,     3,     2,     1,     1,
       3,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 651 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5273 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 652 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 5279 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 653 "core/cfg.y" /* yacc.c:1646  */
    { yyerror(""); YYABORT;}
#line 5285 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 661 "core/cfg.y" /* yacc.c:1646  */
    {rt=REQUEST_ROUTE;}
#line 5291 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 662 "core/cfg.y" /* yacc.c:1646  */
    {rt=FAILURE_ROUTE;}
#line 5297 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 664 "core/cfg.y" /* yacc.c:1646  */
    {rt=BRANCH_ROUTE;}
#line 5303 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 665 "core/cfg.y" /* yacc.c:1646  */
    {rt=ONSEND_ROUTE;}
#line 5309 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 666 "core/cfg.y" /* yacc.c:1646  */
    {rt=EVENT_ROUTE;}
#line 5315 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 671 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].ipaddr)){
			tmp=ip_addr2a((yyvsp[0].ipaddr));
			if (tmp==0) {
				LM_CRIT("cfg. parser: bad ip address.\n");
				(yyval.strval)=0;
			} else {
				(yyval.strval)=pkg_malloc(strlen(tmp)+1);
				if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
				} else {
					strncpy((yyval.strval), tmp, strlen(tmp)+1);
				}
			}
		}
	}
#line 5336 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 687 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
		if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
		} else {
				strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
		}
	}
#line 5349 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 695 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
			} else {
					strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
			}
		}
	}
#line 5364 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 709 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), SI_IS_MHOMED); }
#line 5370 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 710 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[-2].strval), SI_IS_MHOMED);
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[0].name_l);
									}
#line 5378 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 716 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=(yyvsp[-1].name_l); }
#line 5384 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 717 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), 0); }
#line 5390 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 721 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5396 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 722 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5402 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 723 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5408 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 724 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5414 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 725 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5420 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 728 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_UDP; }
#line 5426 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 729 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TCP; }
#line 5432 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 730 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_TLS; }
#line 5438 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 731 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_SCTP; }
#line 5444 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 732 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WS; }
#line 5450 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 733 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=PROTO_WSS; }
#line 5456 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 734 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5462 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 737 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=(yyvsp[0].intval); }
#line 5468 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 738 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=0; }
#line 5474 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 741 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), 0, 0); }
#line 5480 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 742 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), 0, (yyvsp[0].intval)); }
#line 5486 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 743 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 5492 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 744 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5498 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 745 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5504 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 749 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), 0, 0); }
#line 5510 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 750 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), 0, (yyvsp[0].intval)); }
#line 5516 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 751 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), (yyvsp[-2].intval), 0); }
#line 5522 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 752 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5528 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 753 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5534 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 757 "core/cfg.y" /* yacc.c:1646  */
    {  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 5540 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 758 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.sockid)=(yyvsp[-1].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 5546 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 762 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=-(yyvsp[0].intval); }
#line 5552 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 766 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("flag list expected\n"); }
#line 5558 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 772 "core/cfg.y" /* yacc.c:1646  */
    { if (register_flag((yyvsp[0].strval),-1)<0)
								yyerror("register flag failed");
						}
#line 5566 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 775 "core/cfg.y" /* yacc.c:1646  */
    {
						if (register_flag((yyvsp[-2].strval), (yyvsp[0].intval))<0)
								yyerror("register flag failed");
										}
#line 5575 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 781 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5581 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 782 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 5587 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 787 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("avpflag list expected\n"); }
#line 5593 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 794 "core/cfg.y" /* yacc.c:1646  */
    {
		if (register_avpflag((yyvsp[0].strval))==0)
			yyerror("cannot declare avpflag");
	}
#line 5602 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 800 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.debug=(yyvsp[0].intval); }
#line 5608 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 801 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 5614 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 802 "core/cfg.y" /* yacc.c:1646  */
    { dont_fork= ! (yyvsp[0].intval); }
#line 5620 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 803 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5626 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 804 "core/cfg.y" /* yacc.c:1646  */
    { set_fork_delay((yyvsp[0].intval)); }
#line 5632 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 805 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5638 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 806 "core/cfg.y" /* yacc.c:1646  */
    { set_modinit_delay((yyvsp[0].intval)); }
#line 5644 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 807 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5650 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 808 "core/cfg.y" /* yacc.c:1646  */
    { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/
					if(log_stderr == 0) log_stderr=(yyvsp[0].intval);
				   }
#line 5658 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 811 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 812 "core/cfg.y" /* yacc.c:1646  */
    {
		if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	}
#line 5675 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 818 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ID expected"); }
#line 5681 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 819 "core/cfg.y" /* yacc.c:1646  */
    { log_name=(yyvsp[0].strval); }
#line 5687 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 820 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5693 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 821 "core/cfg.y" /* yacc.c:1646  */
    { log_color=(yyvsp[0].intval); }
#line 5699 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 822 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5705 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 823 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_fmt=(yyvsp[0].strval); }
#line 5711 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 824 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5717 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 825 "core/cfg.y" /* yacc.c:1646  */
    { log_prefix_mode=(yyvsp[0].intval); }
#line 5723 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 826 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5729 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 827 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_type=(yyvsp[0].strval); }
#line 5735 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 828 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5741 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 829 "core/cfg.y" /* yacc.c:1646  */
    { _km_log_engine_data=(yyvsp[0].strval); }
#line 5747 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 830 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 831 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_params.len=strlen((yyvsp[0].strval));
		}
#line 5761 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 834 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5767 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 835 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_fields.len=strlen((yyvsp[0].strval));
		}
#line 5775 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 838 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 5781 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 839 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 5787 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 840 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5793 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 841 "core/cfg.y" /* yacc.c:1646  */
    { received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 5799 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 842 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5805 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 843 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_try_ipv6=(yyvsp[0].intval); }
#line 5811 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 844 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5817 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 845 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[0].intval)); }
#line 5823 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 846 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5829 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 847 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[0].intval)); }
#line 5835 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 848 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5841 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 849 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[0].intval));}
#line 5847 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 850 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5853 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 851 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[0].intval));}
#line 5859 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 852 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5865 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 853 "core/cfg.y" /* yacc.c:1646  */
    { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[0].intval));}
#line 5871 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 854 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5877 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 855 "core/cfg.y" /* yacc.c:1646  */
    {
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[0].intval)); }
#line 5884 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 857 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5890 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 858 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_time=(yyvsp[0].intval); }
#line 5896 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 859 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5902 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 860 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_slow_query_ms=(yyvsp[0].intval); }
#line 5908 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 861 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5914 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 862 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_retr_no=(yyvsp[0].intval); }
#line 5920 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 863 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5926 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 864 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_servers_no=(yyvsp[0].intval); }
#line 5932 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 865 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 5938 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 866 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_list=(yyvsp[0].intval); }
#line 5944 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 867 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5950 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 868 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_search_fmatch=(yyvsp[0].intval); }
#line 5956 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 869 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5962 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 870 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.dns_naptr_ignore_rfc=(yyvsp[0].intval); }
#line 5968 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 871 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5974 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 872 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_cache_init=(yyvsp[0].intval)); }
#line 5980 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 873 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5986 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 874 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[0].intval)); }
#line 5992 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 875 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 5998 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 876 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[0].intval));}
#line 6004 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 877 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6010 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 878 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[0].intval)); }
#line 6016 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 879 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6022 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 880 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[0].intval)); }
#line 6028 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 881 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6034 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 882 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[0].intval)); }
#line 6040 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 883 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6046 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 884 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[0].intval)); }
#line 6052 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 885 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6058 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 886 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[0].intval)); }
#line 6064 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 887 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6070 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 888 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(dns_timer_interval=(yyvsp[0].intval)); }
#line 6076 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 889 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6082 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 890 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[0].intval)); }
#line 6088 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 891 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6094 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 892 "core/cfg.y" /* yacc.c:1646  */
    { IF_DNS_CACHE(default_core_cfg.dns_cache_rec_pref=(yyvsp[0].intval)); }
#line 6100 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 893 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6106 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 894 "core/cfg.y" /* yacc.c:1646  */
    {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[0].intval));}
#line 6112 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 895 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6118 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 896 "core/cfg.y" /* yacc.c:1646  */
    {
		ksr_ipv6_hex_style.s = (yyvsp[0].strval);
		if(ksr_ipv6_hex_style.s[0]!='a' && ksr_ipv6_hex_style.s[0]!='A'
				&& ksr_ipv6_hex_style.s[0]!='c') {
			yyerror("expected \"a\", \"A\" or \"c\" value");
		}
		ksr_ipv6_hex_style.len = strlen(ksr_ipv6_hex_style.s);
	}
#line 6131 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 904 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6137 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 905 "core/cfg.y" /* yacc.c:1646  */
    {sr_bind_ipv6_link_local = (yyvsp[0].intval);}
#line 6143 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 906 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6149 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 907 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLOCKLIST(dst_blocklist_init=(yyvsp[0].intval)); }
#line 6155 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 908 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6161 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 909 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.use_dst_blocklist=(yyvsp[0].intval));
	}
#line 6169 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 912 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6175 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 913 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_max_mem=(yyvsp[0].intval));
	}
#line 6183 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 916 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6189 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 917 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_timeout=(yyvsp[0].intval));
	}
#line 6197 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 920 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6203 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 921 "core/cfg.y" /* yacc.c:1646  */
    { IF_DST_BLOCKLIST(blst_timer_interval=(yyvsp[0].intval));}
#line 6209 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 922 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6215 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 923 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_udp_imask=(yyvsp[0].intval));
	}
#line 6223 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 926 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6229 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 927 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[0].intval));
	}
#line 6237 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 930 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6243 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 931 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_tls_imask=(yyvsp[0].intval));
	}
#line 6251 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 934 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6257 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 935 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[0].intval));
	}
#line 6265 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 938 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number(flags) expected"); }
#line 6271 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 939 "core/cfg.y" /* yacc.c:1646  */
    { _sr_ip_free_bind=(yyvsp[0].intval); }
#line 6277 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 940 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6283 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 941 "core/cfg.y" /* yacc.c:1646  */
    { port_no=(yyvsp[0].intval); }
#line 6289 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 942 "core/cfg.y" /* yacc.c:1646  */
    { maxbuffer=(yyvsp[0].intval); }
#line 6295 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 943 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6301 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 944 "core/cfg.y" /* yacc.c:1646  */
    { sql_buffer_size=(yyvsp[0].intval); }
#line 6307 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 945 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6313 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 946 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6319 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 947 "core/cfg.y" /* yacc.c:1646  */
    { children_no=(yyvsp[0].intval); }
#line 6325 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 948 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6331 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 949 "core/cfg.y" /* yacc.c:1646  */
    { ksr_stats_namesep=(yyvsp[0].strval); }
#line 6337 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 950 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6343 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 951 "core/cfg.y" /* yacc.c:1646  */
    { socket_workers=(yyvsp[0].intval); }
#line 6349 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 952 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6355 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 953 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_workers((yyvsp[0].intval)); }
#line 6361 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 954 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6367 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 955 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_usleep((yyvsp[0].intval)); }
#line 6373 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 956 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6379 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 957 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_nonblock((yyvsp[0].intval)); }
#line 6385 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 958 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6391 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 959 "core/cfg.y" /* yacc.c:1646  */
    { async_task_set_workers_group((yyvsp[0].strval)); }
#line 6397 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 960 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 6403 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 961 "core/cfg.y" /* yacc.c:1646  */
    { check_via=(yyvsp[0].intval); }
#line 6409 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 962 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6415 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 963 "core/cfg.y" /* yacc.c:1646  */
    { phone2tel=(yyvsp[0].intval); }
#line 6421 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 964 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6427 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 965 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memlog=(yyvsp[0].intval); }
#line 6433 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 966 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6439 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 967 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.memdbg=(yyvsp[0].intval); }
#line 6445 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 968 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6451 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 969 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_summary=(yyvsp[0].intval); }
#line 6457 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 970 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6463 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 971 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_safety=(yyvsp[0].intval); }
#line 6469 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 972 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6475 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 973 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_join=(yyvsp[0].intval); }
#line 6481 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 974 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6487 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 975 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.mem_status_mode=(yyvsp[0].intval); }
#line 6493 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 976 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6499 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 977 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.sip_parser_log_oneline=(yyvsp[0].intval); }
#line 6505 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 978 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6511 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 979 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.sip_parser_log=(yyvsp[0].intval); }
#line 6517 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 980 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6523 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 981 "core/cfg.y" /* yacc.c:1646  */
    { ksr_sip_parser_mode=(yyvsp[0].intval); }
#line 6529 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 982 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6535 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 983 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.corelog=(yyvsp[0].intval); }
#line 6541 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 984 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 6547 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 985 "core/cfg.y" /* yacc.c:1646  */
    { sip_warning=(yyvsp[0].intval); }
#line 6553 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 986 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6559 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 987 "core/cfg.y" /* yacc.c:1646  */
    { version_table.s=(yyvsp[0].strval);
			version_table.len=strlen(version_table.s);
	}
#line 6567 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 990 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6573 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 991 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6585 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 998 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6597 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1005 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6603 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1006 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6609 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1007 "core/cfg.y" /* yacc.c:1646  */
    { group=(yyvsp[0].strval); }
#line 6615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1008 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6621 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1009 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6627 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1010 "core/cfg.y" /* yacc.c:1646  */
    { chroot_dir=(yyvsp[0].strval); }
#line 6633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1011 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6639 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1012 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6645 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1013 "core/cfg.y" /* yacc.c:1646  */
    { working_dir=(yyvsp[0].strval); }
#line 6651 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1014 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6657 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1015 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6663 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1016 "core/cfg.y" /* yacc.c:1646  */
    { runtime_dir=(yyvsp[0].strval); }
#line 6669 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1017 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 6675 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1018 "core/cfg.y" /* yacc.c:1646  */
    { mhomed=(yyvsp[0].intval); }
#line 6681 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1019 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6687 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1020 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6699 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1027 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6705 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1028 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6717 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1035 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6723 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1036 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_accept_unique=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6735 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1043 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6741 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1044 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_connection_match=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1051 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6759 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1052 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6771 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1059 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6777 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1060 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6789 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1067 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1068 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6807 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1075 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6813 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1076 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if ((yyvsp[0].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6828 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1086 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6834 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1087 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6853 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1101 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6872 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1115 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("poll method name expected"); }
#line 6878 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1116 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6890 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1123 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6896 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1124 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6908 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1131 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 6914 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1132 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6926 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1139 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6932 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1140 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6946 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1149 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv4 address expected"); }
#line 6952 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1150 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
				if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6966 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1159 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("IPv6 address expected"); }
#line 6972 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1160 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6984 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1167 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 6990 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1168 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7002 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1175 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7008 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1176 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7020 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1183 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7026 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1184 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7038 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1191 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7044 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1192 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7056 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1199 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7062 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1200 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7074 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1207 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7080 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1208 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7092 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1215 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7098 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1216 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7110 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1223 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7116 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1224 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7128 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1231 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7134 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1232 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7146 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1239 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7152 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1240 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7164 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1247 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected");}
#line 7170 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1248 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7182 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1255 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7188 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1256 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7200 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1263 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7206 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1264 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7218 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1271 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7224 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1272 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7236 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1279 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7242 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1280 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7254 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1287 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7260 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1288 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_hep3=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7272 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1295 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7278 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1296 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_accept_haproxy=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7290 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1303 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7296 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1305 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7308 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1312 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7314 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1313 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
		#ifdef SO_REUSEPORT
			tcp_default_cfg.reuse_port=(yyvsp[0].intval);
		#else
			warn("support for SO_REUSEPORT not compiled in");
		#endif
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7330 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1324 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7336 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1325 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			tcp_default_cfg.wait_data_ms=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7348 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1332 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7354 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1333 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			ksr_tcp_script_mode=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7366 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1340 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7372 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1341 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7384 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1348 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7390 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1349 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[0].intval));
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7402 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1356 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7408 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1357 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_log=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7420 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1364 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 7426 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1365 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7438 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1372 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7444 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1373 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7456 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1380 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7468 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1387 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7480 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1394 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7492 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1401 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7504 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1408 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7516 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1415 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7522 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1416 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[0].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	}
#line 7534 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1423 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7540 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 1424 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7552 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 1431 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7558 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1432 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7570 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1439 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7576 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 1440 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7588 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 1447 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7594 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1448 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7606 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1455 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7612 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1456 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7624 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1463 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7630 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1464 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7642 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1471 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7648 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1472 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[0].intval)<=1)?!(yyvsp[0].intval):(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7660 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1479 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean or number expected"); }
#line 7666 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1480 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7678 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1487 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 7684 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1488 "core/cfg.y" /* yacc.c:1646  */
    { server_signature=(yyvsp[0].intval); }
#line 7690 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1489 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7696 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1490 "core/cfg.y" /* yacc.c:1646  */
    { server_hdr.s=(yyvsp[0].strval);
			server_hdr.len=strlen(server_hdr.s);
	}
#line 7704 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1493 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7710 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1494 "core/cfg.y" /* yacc.c:1646  */
    { user_agent_hdr.s=(yyvsp[0].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	}
#line 7718 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1497 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7724 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1498 "core/cfg.y" /* yacc.c:1646  */
    { _sr_uri_host_extra_chars=(yyvsp[0].strval); }
#line 7730 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1499 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7736 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1500 "core/cfg.y" /* yacc.c:1646  */
    { _ksr_hname_extra_chars=(unsigned char*)(yyvsp[0].strval); }
#line 7742 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1501 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string value expected"); }
#line 7748 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1502 "core/cfg.y" /* yacc.c:1646  */
    { reply_to_via=(yyvsp[0].intval); }
#line 7754 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1503 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 7760 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1504 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7777 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1516 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-1].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_iface(   lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-1].sockid));
        }
#line 7795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1529 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 7812 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1541 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-3].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
                        lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto, (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-3].sockid));
        }
#line 7830 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1554 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7848 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1567 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-5].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface( lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-3].strval), (yyvsp[-1].intval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-5].sockid));
        }
#line 7867 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1581 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-6].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-4].strval), (yyvsp[-2].intval), (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-6].sockid));
	}
#line 7885 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1594 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-7].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-5].strval), (yyvsp[-3].intval), (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-7].sockid));
        }
#line 7904 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1608 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[0].strval), 0,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 7922 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1621 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-3].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface( lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-1].strval), 0,
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-3].sockid));
        }
#line 7941 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1635 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), 0, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7959 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1648 "core/cfg.y" /* yacc.c:1646  */
    {
                for(lst_tmp=(yyvsp[-5].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-3].strval), 0, (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-5].sockid));
        }
#line 7978 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1662 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("ip address, interface name or"
									" hostname expected"); }
#line 7985 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1664 "core/cfg.y" /* yacc.c:1646  */
    {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 8001 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1675 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("hostname expected"); }
#line 8007 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1676 "core/cfg.y" /* yacc.c:1646  */
    { sr_auto_aliases=(yyvsp[0].intval); }
#line 8013 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1677 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8019 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1678 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].strval)){
			default_global_address.s=(yyvsp[0].strval);
			default_global_address.len=strlen((yyvsp[0].strval));
		}
	}
#line 8030 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1684 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 8036 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 1685 "core/cfg.y" /* yacc.c:1646  */
    {
		tmp=int2str((yyvsp[0].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			PKG_MEM_CRITICAL;
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	}
#line 8051 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1695 "core/cfg.y" /* yacc.c:1646  */
    {yyerror("ip address or hostname expected"); }
#line 8057 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1696 "core/cfg.y" /* yacc.c:1646  */
    { disable_core_dump=(yyvsp[0].intval); }
#line 8063 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1697 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8069 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1698 "core/cfg.y" /* yacc.c:1646  */
    { open_files_limit=(yyvsp[0].intval); }
#line 8075 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1699 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8081 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1700 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0 || shm_mem_size == SHM_MEM_POOL_SIZE)
			shm_mem_size=(yyvsp[0].intval) * 1024 * 1024;
	}
#line 8093 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1707 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1708 "core/cfg.y" /* yacc.c:1646  */
    {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[0].intval);
	}
#line 8111 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1715 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8117 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1716 "core/cfg.y" /* yacc.c:1646  */
    { mlock_pages=(yyvsp[0].intval); }
#line 8123 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1717 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8129 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1718 "core/cfg.y" /* yacc.c:1646  */
    { real_time=(yyvsp[0].intval); }
#line 8135 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1719 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8141 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1720 "core/cfg.y" /* yacc.c:1646  */
    { rt_prio=(yyvsp[0].intval); }
#line 8147 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 1721 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8153 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 1722 "core/cfg.y" /* yacc.c:1646  */
    { rt_policy=(yyvsp[0].intval); }
#line 8159 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1723 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8165 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1724 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_prio=(yyvsp[0].intval); }
#line 8171 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1725 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8177 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 1726 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer1_policy=(yyvsp[0].intval); }
#line 8183 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 1727 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8189 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 1728 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_prio=(yyvsp[0].intval); }
#line 8195 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 1729 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8201 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 1730 "core/cfg.y" /* yacc.c:1646  */
    { rt_timer2_policy=(yyvsp[0].intval); }
#line 8207 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 1731 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8213 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 1732 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8225 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1739 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8231 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1740 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8243 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1747 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8249 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 1748 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8261 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 1755 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8273 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1762 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8279 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1763 "core/cfg.y" /* yacc.c:1646  */
    { tos=(yyvsp[0].intval); }
#line 8285 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1764 "core/cfg.y" /* yacc.c:1646  */
    { if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	}
#line 8317 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 1791 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8323 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 1792 "core/cfg.y" /* yacc.c:1646  */
    { pmtu_discovery=(yyvsp[0].intval); }
#line 8329 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 1793 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8335 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 1794 "core/cfg.y" /* yacc.c:1646  */
    { ser_kill_timeout=(yyvsp[0].intval); }
#line 8341 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1795 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8347 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1796 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.max_while_loops=(yyvsp[0].intval); }
#line 8353 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 1797 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8359 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 1798 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_size((yyvsp[0].intval)); }
#line 8365 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1799 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8371 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1800 "core/cfg.y" /* yacc.c:1646  */
    { pv_set_buffer_slots((yyvsp[0].intval)); }
#line 8377 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1801 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8383 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1802 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_limit=(yyvsp[0].intval); }
#line 8389 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1803 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8395 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1804 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.pv_cache_action=(yyvsp[0].intval); }
#line 8401 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 1805 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8407 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 1806 "core/cfg.y" /* yacc.c:1646  */
    { http_reply_parse=(yyvsp[0].intval); }
#line 8413 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 1807 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8419 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 1808 "core/cfg.y" /* yacc.c:1646  */
    { ksr_verbose_startup=(yyvsp[0].intval); }
#line 8425 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 1809 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8431 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 1810 "core/cfg.y" /* yacc.c:1646  */
    { ksr_route_locks_size=(yyvsp[0].intval); }
#line 8437 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 1811 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8443 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1812 "core/cfg.y" /* yacc.c:1646  */
    { ksr_wait_worker1_mode=(yyvsp[0].intval); }
#line 8449 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 1813 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8455 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1814 "core/cfg.y" /* yacc.c:1646  */
    { ksr_wait_worker1_time=(yyvsp[0].intval); }
#line 8461 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 1815 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8467 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 1816 "core/cfg.y" /* yacc.c:1646  */
    { ksr_wait_worker1_usleep=(yyvsp[0].intval); }
#line 8473 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1817 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8479 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1818 "core/cfg.y" /* yacc.c:1646  */
    { server_id=(yyvsp[0].intval); }
#line 8485 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1819 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8491 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 1820 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_onsend_route_callback.s = (yyvsp[0].strval);
			kemi_onsend_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_onsend_route_callback.len==4
					&& strcasecmp(kemi_onsend_route_callback.s, "none")==0) {
				kemi_onsend_route_callback.s = "";
				kemi_onsend_route_callback.len = 0;
			}
		}
#line 8505 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 1829 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8511 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 1830 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_reply_route_callback.s = (yyvsp[0].strval);
			kemi_reply_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_reply_route_callback.len==4
					&& strcasecmp(kemi_reply_route_callback.s, "none")==0) {
				kemi_reply_route_callback.s = "";
				kemi_reply_route_callback.len = 0;
			}
		}
#line 8525 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 1839 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8531 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1840 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_event_route_callback.s = (yyvsp[0].strval);
			kemi_event_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_event_route_callback.len==4
					&& strcasecmp(kemi_event_route_callback.s, "none")==0) {
				kemi_event_route_callback.s = "";
				kemi_event_route_callback.len = 0;
			}
		}
#line 8545 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 1849 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8551 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 1850 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_received_route_callback.s = (yyvsp[0].strval);
			kemi_received_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_received_route_callback.len==4
					&& strcasecmp(kemi_received_route_callback.s, "none")==0) {
				kemi_received_route_callback.s = "";
				kemi_received_route_callback.len = 0;
			}
		}
#line 8565 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 1859 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8571 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 1860 "core/cfg.y" /* yacc.c:1646  */
    {
			kemi_pre_routing_callback.s = (yyvsp[0].strval);
			kemi_pre_routing_callback.len = strlen((yyvsp[0].strval));
			if(kemi_pre_routing_callback.len==4
					&& strcasecmp(kemi_pre_routing_callback.s, "none")==0) {
				kemi_pre_routing_callback.s = "";
				kemi_pre_routing_callback.len = 0;
			}
		}
#line 8585 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1869 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8591 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 1870 "core/cfg.y" /* yacc.c:1646  */
    { ksr_evrt_received_mode=(yyvsp[0].intval); }
#line 8597 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1871 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8603 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 1872 "core/cfg.y" /* yacc.c:1646  */
    { set_max_recursive_level((yyvsp[0].intval)); }
#line 8609 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 1873 "core/cfg.y" /* yacc.c:1646  */
    { sr_dst_max_branches = (yyvsp[0].intval); }
#line 8615 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1874 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_log=(yyvsp[0].intval); }
#line 8621 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1875 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8627 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1876 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_cfg_log=(yyvsp[0].intval); }
#line 8633 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 1877 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8639 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 1878 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_db=(yyvsp[0].intval); }
#line 8645 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1879 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8651 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1880 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_action=(yyvsp[0].intval); }
#line 8657 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1881 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8663 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 1882 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.latency_limit_cfg=(yyvsp[0].intval); }
#line 8669 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 1883 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8675 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 1884 "core/cfg.y" /* yacc.c:1646  */
    { sr_msg_time=(yyvsp[0].intval); }
#line 8681 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1885 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number  expected"); }
#line 8687 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 1886 "core/cfg.y" /* yacc.c:1646  */
    { onsend_route_reply=(yyvsp[0].intval); }
#line 8693 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1887 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("int value expected"); }
#line 8699 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1888 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu=(yyvsp[0].intval); }
#line 8705 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1889 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8711 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 1891 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.force_rport=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 8717 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 1892 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8723 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 1893 "core/cfg.y" /* yacc.c:1646  */
    { ksr_local_rport=(yyvsp[0].intval); }
#line 8729 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 1894 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("boolean value expected"); }
#line 8735 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 1896 "core/cfg.y" /* yacc.c:1646  */
    { default_core_cfg.udp_mtu_try_proto=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 8741 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 1898 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("TCP, TLS, SCTP or UDP expected"); }
#line 8747 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 1899 "core/cfg.y" /* yacc.c:1646  */
    { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[0].intval)); }
#line 8753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 1900 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8759 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 1901 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[0].intval));
	}
#line 8767 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 1904 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8773 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 1905 "core/cfg.y" /* yacc.c:1646  */
    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[0].intval));
	}
#line 8781 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 1908 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("number expected"); }
#line 8787 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 1910 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("unknown config variable"); }
#line 8793 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 1914 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8799 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 1918 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)="default" ; }
#line 8805 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 1919 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("cfg var field name - use of number or reserved token not allowed: %s",
				yy_number_str);
		YYERROR;
	}
#line 8815 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 1927 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8825 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 1932 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8835 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 1937 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_int((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].intval), 0, 0, (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8845 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 1942 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_declare_str((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 1947 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("number or string expected");
	}
#line 8863 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 1950 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_int((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8873 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 1955 "core/cfg.y" /* yacc.c:1646  */
    {
		if (cfg_ginst_var_string((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8883 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 1963 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (load_module((yyvsp[0].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 8894 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 1969 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8900 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 1970 "core/cfg.y" /* yacc.c:1646  */
    {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (load_modulex((yyvsp[0].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 8911 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 1976 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8917 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 1977 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8932 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 1987 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8938 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 1988 "core/cfg.y" /* yacc.c:1646  */
    {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8953 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 1998 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 8959 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 1999 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8973 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2008 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8987 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2017 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 8993 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2018 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9007 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2027 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9021 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2036 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_VAR, (void*)(yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9035 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2045 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("Invalid arguments"); }
#line 9041 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2046 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 9052 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2052 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9058 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2053 "core/cfg.y" /* yacc.c:1646  */
    {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 9069 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2059 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("string expected"); }
#line 9075 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2063 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9081 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2064 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9087 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2067 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[-6].intval)>255) || ((yyvsp[-6].intval)<0) ||
				((yyvsp[-4].intval)>255) || ((yyvsp[-4].intval)<0) ||
				((yyvsp[-2].intval)>255) || ((yyvsp[-2].intval)<0) ||
				((yyvsp[0].intval)>255) || ((yyvsp[0].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[-6].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[-4].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[-2].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[0].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	}
#line 9119 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2096 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		}
	}
#line 9137 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2111 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9143 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2112 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 9149 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2116 "core/cfg.y" /* yacc.c:1646  */
    {
					tmp=int2str((yyvsp[0].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
					routename = tmp;
						}
#line 9165 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2127 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 9171 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2128 "core/cfg.y" /* yacc.c:1646  */
    { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 9177 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2132 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9183 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2133 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9189 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2137 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[DEFAULT_RT]);
	}
#line 9201 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2144 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&main_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[i_tmp]);
	}
#line 9222 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2160 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  route  statement"); }
#line 9228 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2161 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid  request_route  statement"); }
#line 9234 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2164 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9240 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2167 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[DEFAULT_RT]);
	}
#line 9252 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2174 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&failure_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[i_tmp]);
	}
#line 9273 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2190 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid failure_route statement"); }
#line 9279 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2194 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9285 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2195 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9291 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2200 "core/cfg.y" /* yacc.c:1646  */
    {rt=CORE_ONREPLY_ROUTE;}
#line 9297 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2200 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
	}
#line 9309 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2207 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 9315 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2208 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onreply_route statement"); }
#line 9321 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2210 "core/cfg.y" /* yacc.c:1646  */
    {rt=(*(yyvsp[-1].strval)=='0' && (yyvsp[-1].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;}
#line 9327 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2211 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (*(yyvsp[-5].strval)=='0' && (yyvsp[-5].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[-5].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[-1].action), &onreply_rt.rlist[i_tmp]);
		}
	}
#line 9353 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2232 "core/cfg.y" /* yacc.c:1646  */
    {
		yyerror("invalid onreply_route statement");
	}
#line 9361 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2237 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9367 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2240 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[DEFAULT_RT]);
	}
#line 9379 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2247 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&branch_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[i_tmp]);
	}
#line 9400 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2263 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid branch_route statement"); }
#line 9406 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2266 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9412 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2269 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[DEFAULT_RT]);
	}
#line 9424 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2276 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&onsend_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[i_tmp]);
	}
#line 9445 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2292 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid onsend_route statement"); }
#line 9451 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2295 "core/cfg.y" /* yacc.c:1646  */
    { routename=NULL; }
#line 9457 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2298 "core/cfg.y" /* yacc.c:1646  */
    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&event_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &event_rt.rlist[i_tmp]);
	}
#line 9478 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2315 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid event_route statement"); }
#line 9484 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2318 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_subst_add((yyvsp[0].strval))<0) YYERROR; }
#line 9490 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2319 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid subst preprocess statement"); }
#line 9496 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2320 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), KSR_PPDEF_NORMAL)<0) YYERROR; }
#line 9502 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2321 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdef preprocess statement"); }
#line 9508 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2322 "core/cfg.y" /* yacc.c:1646  */
    { if(pp_substdef_add((yyvsp[0].strval), KSR_PPDEF_QUOTED)<0) YYERROR; }
#line 9514 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2323 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("invalid substdefs preprocess statement"); }
#line 9520 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2345 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 9526 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2346 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 9532 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2347 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=EQUAL_OP; }
#line 9538 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2348 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=DIFF_OP; }
#line 9544 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2351 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GT_OP; }
#line 9550 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2352 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LT_OP; }
#line 9556 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2353 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=GTE_OP; }
#line 9562 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2354 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=LTE_OP; }
#line 9568 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2357 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=(yyvsp[0].intval); }
#line 9574 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2358 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=MATCH_OP; }
#line 9580 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2364 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_EQ_OP; }
#line 9586 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2365 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_DIFF_OP; }
#line 9592 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2366 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IEQ_OP; }
#line 9598 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2367 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_IDIFF_OP; }
#line 9604 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2368 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STREQ_OP; }
#line 9610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2369 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_STRDIFF_OP; }
#line 9616 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2370 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_MATCH_OP; }
#line 9622 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2373 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GT_OP; }
#line 9628 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2374 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LT_OP; }
#line 9634 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2375 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_GTE_OP; }
#line 9640 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2376 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=RVE_LTE_OP; }
#line 9646 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2383 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=URI_O;}
#line 9652 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2384 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=FROM_URI_O;}
#line 9658 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2385 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.intval)=TO_URI_O;}
#line 9664 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2392 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDPORT_O; }
#line 9670 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2393 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=TOPORT_O; }
#line 9676 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2394 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SNDAF_O; }
#line 9682 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2398 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCPORT_O; }
#line 9688 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2399 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTPORT_O; }
#line 9694 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2400 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=AF_O; }
#line 9700 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2401 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=MSGLEN_O; }
#line 9706 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2407 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; }
#line 9712 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2408 "core/cfg.y" /* yacc.c:1646  */
    { onsend_check("to_ip");  (yyval.intval)=TOIP_O; }
#line 9718 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2411 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=SRCIP_O; }
#line 9724 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2412 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=DSTIP_O; }
#line 9730 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2420 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)= mk_elem((yyvsp[-1].intval), METHOD_O, 0, RVE_ST, (yyvsp[0].rv_expr));}
#line 9736 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2422 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), METHOD_O, 0, STRING_ST,(yyvsp[0].strval)); }
#line 9742 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2423 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string expected"); }
#line 9748 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2425 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); }
#line 9754 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2427 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr) = mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr)); }
#line 9760 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2429 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9766 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2431 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("string or MYSELF expected"); }
#line 9772 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2433 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); }
#line 9778 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2434 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9784 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2436 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9790 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2437 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 9796 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2438 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("number expected"); }
#line 9802 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2439 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); }
#line 9808 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2441 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9814 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2443 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9820 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2445 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9826 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2447 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9832 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2449 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9838 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2451 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9844 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2452 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST, (yyvsp[0].ipnet)); }
#line 9850 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2453 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[0].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[0].rv_expr));
				if (i_tmp==RV_INT)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[0].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST,
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
			}
		}
#line 9891 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2490 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, STRING_ST, (yyvsp[0].strval)); }
#line 9897 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2492 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9903 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2494 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); }
#line 9909 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2496 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");}
#line 9915 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2499 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9921 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2501 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9927 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2503 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror("URI, SRCIP or DSTIP expected"); }
#line 9933 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2504 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); }
#line 9939 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2508 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net((yyvsp[-2].ipaddr), (yyvsp[0].ipaddr)); }
#line 9945 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2509 "core/cfg.y" /* yacc.c:1646  */
    {
		if (((yyvsp[0].intval)<0) || ((yyvsp[0].intval)>(yyvsp[-2].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[-2].ipaddr), (yyvsp[0].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	}
#line 9961 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2520 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8); }
#line 9967 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2521 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); }
#line 9973 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2525 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 9979 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2526 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9999 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2541 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10019 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2556 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 10025 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2557 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 10031 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2562 "core/cfg.y" /* yacc.c:1646  */
    {
			/* get string version */
			(yyval.strval)=pkg_malloc(strlen(yy_number_str)+1);
			if ((yyval.strval)==0) {
				PKG_MEM_ERROR;
			} else {
				strcpy((yyval.strval), yy_number_str);
			}
		}
#line 10045 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2574 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=(yyvsp[0].strval); }
#line 10051 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2575 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2590 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10091 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2605 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 10098 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2607 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 10105 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 2614 "core/cfg.y" /* yacc.c:1646  */
    {
		/* check if allowed */
		if ((yyvsp[0].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[0].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[0].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[0].action);
		}
	}
#line 10142 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2656 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 10148 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2657 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 10154 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2660 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 10160 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2661 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 10166 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2662 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command"); }
#line 10172 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2665 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 10178 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2666 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 10184 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 2667 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[0].action);}
#line 10190 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2668 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[0].action); }
#line 10196 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2669 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=(yyvsp[-1].action); }
#line 10202 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2670 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=(yyvsp[-1].action);}
#line 10208 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2671 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0;}
#line 10214 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2672 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 10220 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2675 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 10233 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2683 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-3].rv_expr) && rval_expr_int_check((yyvsp[-3].rv_expr))>=0){
			warn_ct_rve((yyvsp[-3].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-3].rv_expr), ACTIONS_ST, (yyvsp[-2].action), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 10246 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2693 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.rv_expr)=0;
			if ((yyvsp[0].rv_expr) && !rve_is_constant((yyvsp[0].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_INT){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[0].rv_expr);
		}
#line 10266 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2710 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10278 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2717 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 1, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10290 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2724 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10302 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2731 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10314 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2738 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10324 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2743 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10334 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2748 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 10340 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2749 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 10346 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2750 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 10352 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2751 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 10358 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2752 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.case_stms)=0; yyerror ("bad case body"); }
#line 10364 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2755 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[-1].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[0].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	}
#line 10378 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2764 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.case_stms)=(yyvsp[0].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	}
#line 10388 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2771 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((yyvsp[-3].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[-1].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-3].rv_expr), CASE_ST, (yyvsp[-1].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 10418 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2796 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[-2].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-2].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 10439 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2812 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror ("bad expression in switch(...)"); }
#line 10445 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2814 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror ("bad switch body"); }
#line 10451 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2818 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[-1].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	}
#line 10466 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2837 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[0].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[0].strval));
		sel.n++;
	}
#line 10480 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2846 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[-1].intval);
		sel.n++;
	}
#line 10497 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2858 "core/cfg.y" /* yacc.c:1646  */
    {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-1].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-1].strval));
		sel.n++;
	}
#line 10515 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2877 "core/cfg.y" /* yacc.c:1646  */
    { sel.n = 0; sel.f[0] = 0; }
#line 10521 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2877 "core/cfg.y" /* yacc.c:1646  */
    {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	}
#line 10534 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2887 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM; }
#line 10540 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2888 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO; }
#line 10546 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2889 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; }
#line 10552 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2890 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; }
#line 10558 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2891 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; }
#line 10564 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2892 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; }
#line 10570 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2893 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; }
#line 10576 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2894 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; }
#line 10582 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2895 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; }
#line 10588 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2898 "core/cfg.y" /* yacc.c:1646  */
    { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[0].strval); s_attr->name.s.len = strlen ((yyvsp[0].strval)); }
#line 10594 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2905 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else { memset(s_attr, 0, (sizeof(struct avp_spec))); }
	}
#line 10604 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2912 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.attr) = s_attr; }
#line 10610 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2915 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[-1].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[-1].intval)<0?-(yyvsp[-1].intval):(yyvsp[-1].intval));
		(yyval.attr) = s_attr;
	}
#line 10620 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2922 "core/cfg.y" /* yacc.c:1646  */
    {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	}
#line 10629 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2944 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[0].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[0].lval));
	}
#line 10646 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2956 "core/cfg.y" /* yacc.c:1646  */
    {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[0].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	}
#line 10673 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2980 "core/cfg.y" /* yacc.c:1646  */
    {
			s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
			pv_spec=pv_cache_get(&s_tmp);
			if (!pv_spec) {
				yyerror("Can't get from cache: %s", (yyvsp[0].strval));
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		}
#line 10687 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2991 "core/cfg.y" /* yacc.c:1646  */
    {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen(s_tmp.s);
				lval_tmp->lv.pvs = pv_cache_get(&s_tmp);
				if (lval_tmp->lv.pvs==NULL){
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambiguous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			}
#line 10713 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 3022 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = ASSIGN_T; }
#line 10719 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 3026 "core/cfg.y" /* yacc.c:1646  */
    {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[0].attr);
					pkg_free((yyvsp[0].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				}
#line 10734 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 3036 "core/cfg.y" /* yacc.c:1646  */
    {
					if (!pv_is_w((yyvsp[0].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[0].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=(yyvsp[0].pvar);
					(yyval.lval)=lval_tmp;
				}
#line 10753 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 3050 "core/cfg.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].lval))->type==LV_PVAR){
						if (!pv_is_w((yyvsp[0].lval)->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[0].lval)->lv.pvs->trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[0].lval);
				}
#line 10768 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 3062 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_INT, (void*)(yyvsp[0].intval)); }
#line 10774 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 3063 "core/cfg.y" /* yacc.c:1646  */
    {	s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); }
#line 10781 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 3065 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[0].attr)); pkg_free((yyvsp[0].attr)); }
#line 10787 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 3066 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].pvar)); }
#line 10793 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 3067 "core/cfg.y" /* yacc.c:1646  */
    {
							switch((yyvsp[0].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[0].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[0].lval)); /* not needed anymore */
						}
#line 10812 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 3081 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[0].select)); pkg_free((yyvsp[0].select)); }
#line 10818 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 3082 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[0].action)); }
#line 10824 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 3083 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[0].expr)); }
#line 10830 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 3084 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10836 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 3085 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad command block"); }
#line 10842 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 3086 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10848 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 3087 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10854 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 3091 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_LNOT_OP; }
#line 10860 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 3092 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_BNOT_OP; }
#line 10866 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 3093 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval)=RVE_UMINUS_OP; }
#line 10872 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 3106 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[0].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									}
#line 10883 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 3112 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1((yyvsp[-1].intval), (yyvsp[0].rv_expr)); }
#line 10889 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 3113 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_INT_OP, (yyvsp[0].rv_expr)); }
#line 10895 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 3114 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[0].rv_expr)); }
#line 10901 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 3115 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10907 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 3116 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10913 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 3117 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10919 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 3118 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10925 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 3119 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10931 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 3120 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr)); }
#line 10937 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 3121 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10943 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 3122 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10949 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 3123 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10955 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 3124 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10961 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3125 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2( (yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10967 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3126 "core/cfg.y" /* yacc.c:1646  */
    {
			/* comparing with $null => treat as defined or !defined */
			if((yyvsp[0].rv_expr) != NULL && (yyvsp[0].rv_expr)->op==RVE_RVAL_OP && (yyvsp[0].rv_expr)->left.rval.type==RV_PVAR
					&& (yyvsp[0].rv_expr)->left.rval.v.pvs.type==PVT_NULL) {
				if((yyvsp[-1].intval)==RVE_DIFF_OP || (yyvsp[-1].intval)==RVE_IDIFF_OP
						|| (yyvsp[-1].intval)==RVE_STRDIFF_OP) {
					DBG("comparison with $null switched to notdefined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[-2].rv_expr));
				} else {
					DBG("comparison with $null switched to defined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_NOTDEFINED_OP, (yyvsp[-2].rv_expr));
				}
				/* free rve struct for $null */
				rve_destroy((yyvsp[0].rv_expr));
			} else {
				(yyval.rv_expr)=mk_rve2((yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));
			}
		}
#line 10990 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3144 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10996 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 3145 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 11002 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 754:
#line 3146 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=(yyvsp[-1].rv_expr);}
#line 11008 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 3147 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[-1].rv_expr));}
#line 11014 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 3148 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[-1].rv_expr));}
#line 11020 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 757:
#line 3149 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[0].rv_expr));}
#line 11026 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 3150 "core/cfg.y" /* yacc.c:1646  */
    {
				rve_tmp=mk_rve2(RVE_SELVALOPT_OP, (yyvsp[-3].rv_expr), (yyvsp[-1].rv_expr));
				if(rve_tmp == NULL) {
					(yyval.rv_expr)=0;
					yyerror("faild to create tenary target expression");
				}
				(yyval.rv_expr)=mk_rve2(RVE_SELVALEXP_OP, (yyvsp[-5].rv_expr), rve_tmp);
		}
#line 11039 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 3158 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11045 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 760:
#line 3159 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11051 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 761:
#line 3160 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11057 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3161 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11063 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3162 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11069 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3163 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11075 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3164 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11081 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3165 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11087 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3166 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11093 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3167 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11099 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3169 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11105 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3171 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11111 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3172 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11117 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3173 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11123 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3174 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11129 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3175 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11135 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3176 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11141 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3177 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11147 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3180 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action((yyvsp[-1].intval), 2, LVAL_ST, (yyvsp[-2].lval),
														 	  RVE_ST, (yyvsp[0].rv_expr));
											set_cfg_pos((yyval.action));
										}
#line 11156 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3198 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 1; }
#line 11162 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3199 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = 0; }
#line 11168 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3200 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.intval) = -1; }
#line 11174 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 781:
#line 3203 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11180 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3204 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11186 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3205 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11192 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3206 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11198 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3207 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11204 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3208 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11210 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3209 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11216 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3210 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11222 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3211 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11228 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3212 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11234 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3213 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11240 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3214 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward argument"); }
#line 11246 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3215 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11252 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3216 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11258 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3217 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11264 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3218 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11270 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3219 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11276 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3220 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11282 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3221 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11288 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3222 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11294 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3223 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11300 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3224 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11306 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3225 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_udp argument"); }
#line 11312 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3226 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11318 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3227 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11324 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3228 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11330 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3229 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11336 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3230 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11342 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3231 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11348 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3232 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11354 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3233 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11360 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3234 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11366 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3235 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11372 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3236 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad forward_tcp argument"); }
#line 11378 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3237 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11391 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3245 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11404 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3253 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11417 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3261 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11430 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3269 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11443 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3277 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					}
#line 11456 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3285 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11469 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3293 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11482 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3301 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11495 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3309 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11501 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3310 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_tls argument"); }
#line 11508 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3312 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11521 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3320 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11534 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 828:
#line 3328 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11547 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 829:
#line 3336 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11561 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 830:
#line 3345 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11575 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3354 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					}
#line 11589 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3363 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11602 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3371 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11616 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 3380 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11629 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3388 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11635 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3389 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0;
									yyerror("bad forward_sctp argument"); }
#line 11642 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3391 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[-1].strval));
									set_cfg_pos((yyval.action)); }
#line 11650 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 3394 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[-3].intval), STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11656 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 3395 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11662 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 3396 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad log argument"); }
#line 11668 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 3397 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11680 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 3404 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11692 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3411 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11698 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3412 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11709 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 3418 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11721 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 3425 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11727 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3426 "core/cfg.y" /* yacc.c:1646  */
    {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11738 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3432 "core/cfg.y" /* yacc.c:1646  */
    {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11750 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 3439 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11756 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 850:
#line 3440 "core/cfg.y" /* yacc.c:1646  */
    {
		i_tmp=get_avpflag_no((yyvsp[-1].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[-3].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[-5].intval));
		set_cfg_pos((yyval.action));
	}
#line 11767 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 851:
#line 3446 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing flag name");
	}
#line 11775 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 3449 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	}
#line 11783 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 3452 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad parameters"); }
#line 11789 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3453 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11795 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 855:
#line 3454 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[-3].strval), STRING_ST, (yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
	}
#line 11803 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 856:
#line 3457 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11809 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 857:
#line 3458 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad error argument"); }
#line 11815 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 858:
#line 3459 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[-1].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11829 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 859:
#line 3468 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[-1].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11843 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 860:
#line 3477 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11849 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 861:
#line 3478 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad route argument"); }
#line 11855 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 862:
#line 3479 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11861 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 863:
#line 3480 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11867 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 3481 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11873 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3482 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11879 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 3483 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11885 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3484 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11891 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 868:
#line 3485 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11897 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 3486 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11903 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 3487 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11909 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3488 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11915 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 872:
#line 3489 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11921 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 873:
#line 3490 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11927 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 874:
#line 3491 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11933 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 875:
#line 3492 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); }
#line 11939 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 3493 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11945 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 3494 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
	}
#line 11954 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 878:
#line 3498 "core/cfg.y" /* yacc.c:1646  */
    {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	}
#line 11963 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 3502 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11969 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 3503 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11975 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 3504 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); }
#line 11981 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 882:
#line 3505 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11987 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 3506 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11993 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 3507 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11999 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 885:
#line 3508 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12005 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 886:
#line 3509 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12011 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 887:
#line 3510 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12017 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 888:
#line 3511 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12023 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 889:
#line 3512 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12029 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 3513 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12035 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 3514 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12041 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3515 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12047 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 3516 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12053 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 894:
#line 3517 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12059 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 3518 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12065 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 3519 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12071 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 897:
#line 3520 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12077 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 898:
#line 3521 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12083 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 899:
#line 3522 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12089 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 900:
#line 3523 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 12095 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 901:
#line 3524 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 12101 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 902:
#line 3525 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12107 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 903:
#line 3526 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12113 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 904:
#line 3527 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12119 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 905:
#line 3528 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12125 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 3529 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12138 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 907:
#line 3537 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12151 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 3545 "core/cfg.y" /* yacc.c:1646  */
    {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12164 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 909:
#line 3553 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12170 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 910:
#line 3555 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12176 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 911:
#line 3557 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); }
#line 12182 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 912:
#line 3558 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			str_tmp->s=(yyvsp[-1].strval);
			str_tmp->len=(yyvsp[-1].strval)?strlen((yyvsp[-1].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	}
#line 12198 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 913:
#line 3569 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12204 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 914:
#line 3570 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12210 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 915:
#line 3571 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0;
		tmp=int2str((yyvsp[-1].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	}
#line 12231 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 916:
#line 3587 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12237 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 917:
#line 3588 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12243 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 918:
#line 3589 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[-1].sockid));
		set_cfg_pos((yyval.action));
	}
#line 12252 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 919:
#line 3593 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	}
#line 12260 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 920:
#line 3596 "core/cfg.y" /* yacc.c:1646  */
    {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12266 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 921:
#line 3597 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12274 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 922:
#line 3600 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12282 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 923:
#line 3603 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12290 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 924:
#line 3606 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12298 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 925:
#line 3609 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12306 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 926:
#line 3612 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12314 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 927:
#line 3615 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12322 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 928:
#line 3618 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12330 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 929:
#line 3621 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
	}
#line 12338 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 930:
#line 3624 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), RVE_ST, (yyvsp[-1].rv_expr)); set_cfg_pos((yyval.action));
	}
#line 12346 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 931:
#line 3627 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12352 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 932:
#line 3628 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string and number expected"); }
#line 12358 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 933:
#line 3629 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action));
	}
#line 12366 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 934:
#line 3632 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12372 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 935:
#line 3633 "core/cfg.y" /* yacc.c:1646  */
    { (yyval.action)=0; yyerror("bad arguments, string expected"); }
#line 12378 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 936:
#line 3634 "core/cfg.y" /* yacc.c:1646  */
    {
		if (mod_func_action != NULL) {
			LM_ERR("function used inside params of another function: %s\n", (yyvsp[0].strval));
			yyerror("use of function execution inside params not allowed\n");
			ksr_exit(-1);
		}
		mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST, 0);
		}
#line 12391 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 937:
#line 3641 "core/cfg.y" /* yacc.c:1646  */
    {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, rt);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, 0) ) {
					LM_ERR("misused command %s\n", (yyvsp[-4].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LM_ERR("cfg. parser: failed to find command %s (params %ld)\n",
						(yyvsp[-4].strval), mod_func_action->val[1].u.number);
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				/* free_mod_func_action(mod_func_action); */
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
		mod_func_action = NULL;
	}
#line 12422 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 938:
#line 3667 "core/cfg.y" /* yacc.c:1646  */
    { yyerror("'('')' expected (function call)");}
#line 12428 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 940:
#line 3671 "core/cfg.y" /* yacc.c:1646  */
    { }
#line 12434 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 941:
#line 3672 "core/cfg.y" /* yacc.c:1646  */
    {}
#line 12440 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 942:
#line 3675 "core/cfg.y" /* yacc.c:1646  */
    {
		if ((yyvsp[0].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[0].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[0].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	}
#line 12459 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 943:
#line 3692 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 12468 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 944:
#line 3696 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 12477 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 945:
#line 3700 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 12486 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 946:
#line 3704 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12496 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 947:
#line 3709 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12505 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 948:
#line 3713 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12515 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 949:
#line 3718 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 12524 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 950:
#line 3722 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 12533 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 951:
#line 3726 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12542 "core/cfg.tab.c" /* yacc.c:1646  */
    break;

  case 952:
#line 3730 "core/cfg.y" /* yacc.c:1646  */
    {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12551 "core/cfg.tab.c" /* yacc.c:1646  */
    break;


#line 12555 "core/cfg.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3736 "core/cfg.y" /* yacc.c:1906  */


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
	pos->rname=(routename!=0)?routename:default_routename;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_WARN("warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_WARN("warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_CRIT("parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_CRIT("parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;

	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_INT && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct name_lst));
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;

	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;

	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;

	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a
 * declared fixup)
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	ksr_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;

	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];

	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}

	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no coresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;

	param_no = a->val[1].u.number;
	params = &a->val[2];

	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/
